
#define _CRT_SECURE_NO_WARNINGS
#define _CRT_NONSTDC_NO_DEPRECATE 
#define _SCL_SECURE_NO_DEPRECATE 
#define _CRT_SECURE_NO_DEPRECATE


#include <stdio.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>
#include <sys/timeb.h>
#include <assert.h>
#include <stdarg.h>
#include <windows.h>

#include "rand48.h"
#include "var.h"



/*----------------------------------------------------------------------
 | VAR     						940420
 |
 | Contains all global variables.
 +----------------------------------------------------------------------*/




BoardIndexType  lastMovedPieceSquare;   /* Square last played piece moved to */
Unsigned1       nrCheck;
CheckPieceType  checkingPiece[2];
DirectionType   pinned[H8 + 1];
SquareType      board[NrSquares];
BoardIndexType  epSquare[MaxGamePlies]; /* EP status during game */
Unsigned1       castling[MaxGamePlies]; /* castling status during game */
HashType        hashValue[MaxGamePlies];        /* hash values of game
                                                 * positions */
Unsigned2       startHashIndex[MaxGamePlies];   /* 50 move rule indices */
SquareType      toMove;
Unsigned4       material[2];
ValueType       positionalValue[2];
Unsigned2       pieceValue[128];
char            pieceSymbol[256];
PieceType       pieces[2][16];
Unsigned1       nrPieces[2];
Unsigned1       pieceIndex[H8 + 1];
BoardIndexType  kingSquare[2];
char            gameString[MaxGamePlies][MaxMoveLength];        /* moveStrings */
MoveType        game[MaxGamePlies];     /* Real moves in the game */
Unsigned2       nrGamePlies,
                maxGamePlies;
Unsigned2       startPly;       /* Ply number of game when the search starts */
SquareType      computer;
Unsigned4       nrInternalNodes,
                nrLeafNodes,
                nrQuiesNodes;
Unsigned4       nrIllegalMoves;
double          startingTime;
Unsigned4       nrTotalNodes,
                nrExtraNodes;
Unsigned2       nrAllocMoveLists,
                nrAllocPathMoves;
Boolean         stopSearching;
char           *moveColorString[2] =
{"BTM", "WTM"};
#ifdef Bcc
Unsigned2 huge  historyTable[2][H8 + 1][H8 + 1];
#else
Unsigned2       historyTable[2][H8 + 1][H8 + 1];
#endif
Signed2         pawnEvalTable[2][H8 + 1];
Signed2         knightEvalTable[2][H8 + 1];
Signed2         bishopEvalTable[2][H8 + 1];
Signed2         rookEvalTable[2][H8 + 1];
Signed2         queenEvalTable[2][H8 + 1];
Signed2         kingEvalTable[2][H8 + 1];
Boolean         interActive,
                doTest,
                useTransTable,
                useRefTable;
Boolean         useTwoLevelTable,
                useTtValue,
                useTtMove,
                timeStamp,
                useFlag;
TtEntry        *transTable;
Unsigned4       nrCollisions,
                nrHits,
                nrReads,
                nrWrites;
Signed4         testNrNodes;
Unsigned1       nrTtBits;
Unsigned2       keepPly;
Unsigned1       keepMethod;
char           *methodString[5] =
{"New", "Old", "Deep", "Big1", "BigAll"};
Unsigned2       debugDepth;

char           *logicString[2] =
{"False", "True"};

/* pack arrays because of transposition table entries */
Unsigned1       packPiece[Edge];
SquareType      unpackPiece[4]; /* 2 bits */
Unsigned1       packSquare[H8 + 1];
BoardIndexType  unpackSquare[64];       /* 6 bits */
Unsigned1       packType[64];
Unsigned1       unpackType[8];  /* 3 bits */

/* move tables */
#ifdef Bcc
BoardIndexType huge knightTable[H8 + 1][MaxKnightMoves];
BoardIndexType huge bishopTable[H8 + 1][4][MaxBishopMoves];
BoardIndexType huge rookTable[H8 + 1][4][MaxRookMoves];
BoardIndexType huge pawnMoveTable[2][H8 + 1][2];
BoardIndexType huge pawnCaptureTable[2][H8 + 1][2];
#else
BoardIndexType  knightTable[H8 + 1][MaxKnightMoves];
BoardIndexType  bishopTable[H8 + 1][4][MaxBishopMoves];
BoardIndexType  rookTable[H8 + 1][4][MaxRookMoves];
BoardIndexType  pawnMoveTable[2][H8 + 1][2];
BoardIndexType  pawnCaptureTable[2][H8 + 1][2];
#endif

/* move directions */
DirectionType   knightDir[8] =
{Up + Up + Right, Up + Up + Left, Down + Down + Right,
    Down + Down + Left, Right + Right + Up, Right + Right + Down,
Left + Left + Up, Left + Left + Down};
DirectionType   bishopDir[4] =
{Up + Right, Up + Left, Down + Right, Down + Left};
DirectionType   rookDir[4] =
{Up, Down, Right, Left};
DirectionType   pawnCaptureDir[2][2] =
{
    {Down + Right, Down + Left},
{Up + Right, Up + Left}};

  

Signed2         centreTable[H8 + 1] =
{   0,  0,  0,   0,   0,   0,   0,   0,  0, 0, 0, 0, 0, 0, 0, 0,
    0,  0,  0,   0,   0,   0,   0,   0,  0, 0, 0, 0, 0, 0, 0, 0,
    0,  0, 10,  20,  40,  40,  20,  10,  0, 0, 0, 0, 0, 0, 0, 0,
    0, 10, 30,  50,  70,  70,  50,  30, 10, 0, 0, 0, 0, 0, 0, 0,
    0, 20, 50,  80, 110, 110,  80,  50, 20, 0, 0, 0, 0, 0, 0, 0,
    0, 40, 70, 110, 160, 160, 110,  70, 40, 0, 0, 0, 0, 0, 0, 0,
    0, 40, 70, 110, 160, 160, 110,  70, 40, 0, 0, 0, 0, 0, 0, 0,
    0, 20, 50,  80, 110, 110,  80,  50, 20, 0, 0, 0, 0, 0, 0, 0,
    0, 10, 30,  50,  70,  70,  50,  30, 10, 0, 0, 0, 0, 0, 0, 0,
    0,  0, 10,  20,  40,  40,  20,  10,  0
};


Signed2         PawnTable[H8 + 1] =
{    0,  0,  0,  0,  0,  0,  0,  0,  0, 0, 0, 0, 0, 0, 0, 0,
     0, 16, 16, 16, 16, 16, 16, 16, 16, 0, 0, 0, 0, 0, 0, 0,
     0,  3,  4,  5,  7,  7,  5,  4,  1, 0, 0, 0, 0, 0, 0, 0, 
     0,  2,  3,  4,  6,  6,  4,  3,  2, 0, 0, 0, 0, 0, 0, 0, 
     0,  0,  1,  5,  8,  8,  5,  1,  0, 0, 0, 0, 0, 0, 0, 0, 
     0,  0,  1,  6, 16, 12,  6,  1,  0, 0, 0, 0, 0, 0, 0, 0, 
     0,  1,  5,  7, 16, 12,  0,  0,  0, 0, 0, 0, 0, 0, 0, 0, 
     0,  5,  8, 10, 16, 12,  0, 16,  0, 0, 0, 0, 0, 0, 0, 0, 
     0,  5,  5,  5,  6,  6, 16,  5, 16, 0, 0, 0, 0, 0, 0, 0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0
};



Signed2         KnightTable[H8 + 1] =
{
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 0, 0, 0, 0, 0, 0,
  0,-16,-10, -8, -8, -8, -8,-10,-16,  0, 0, 0, 0, 0, 0, 0, 
  0,-10, -3,  1,  3,  3,  1, -3,-10,  0, 0, 0, 0, 0, 0, 0, 
  0, -8,  1,  5,  5,  5,  5,  1, -8,  0, 0, 0, 0, 0, 0, 0, 
  0, -8,  2,  5,  8,  8,  5,  2, -8,  0, 0, 0, 0, 0, 0, 0, 
  0, -8,  4,  6, 10, 10,  6,  4, -8,  0, 0, 0, 0, 0, 0, 0, 
  0, -8,  4,  7,  8,  8,  7,  4, -8,  0, 0, 0, 0, 0, 0, 0, 
  0,-10,  0,  3,  4,  4,  3,  0,-10,  0, 0, 0, 0, 0, 0, 0, 
  0,-16,-10, -8, -8, -8, -8,-10,-16,  0, 0, 0, 0, 0, 0, 0, 
  0,  0,  0,  0,  0,  0,  0,  0,  0
}; 


Signed2         RookTable[H8 + 1] =
{   0,  0,  0,   0,   0,   0,   0,   0,  0,  0, 0, 0, 0, 0, 0, 0,
    0,  0,  0,   0,   0,   0,   0,   0,  0,  0, 0, 0, 0, 0, 0, 0,
    0, 10, 11,  12,  13,  13,  12,  11, 10,  0, 0, 0, 0, 0, 0, 0,
    0,  0,  1,   2,   3,   3,   2,   1,  0,  0, 0, 0, 0, 0, 0, 0,
    0,  0,  1,   2,   3,   3,   2,   1,  0,  0, 0, 0, 0, 0, 0, 0,
    0,  0,  1,   2,   3,   3,   2,   1,  0,  0, 0, 0, 0, 0, 0, 0,
    0,  7,  8,   9,  10,  10,   9,   8,  7,  0, 0, 0, 0, 0, 0, 0, 
    0, 10, 11,  12,  13,  13,  12,  11,  10, 0, 0, 0, 0, 0, 0, 0,
    0, 10, 11,  12,  13,  13,  12,  11,  10, 0, 0, 0, 0, 0, 0, 0,
    0,  0,  0,   0,   0,   0,   0,   0 
};


Signed2         BishopTable[H8 + 1] =
{
    0,  0,  0,   0,   0,   0,   0,   0,  0,  0, 0, 0, 0, 0, 0, 0,
	0, 10,  8,   6,   4,   4,   6,   8,  10, 0, 0, 0, 0, 0, 0, 0, 
    0,  8, 12,   8,   9,   9,   8,  12,   8, 0, 0, 0, 0, 0, 0, 0, 
    0, 10, 10,  11,  11,  11,  11,  10,  10, 0, 0, 0, 0, 0, 0, 0,
    0, 11, 12,  13,  14,  14,  13,  12,  11, 0, 0, 0, 0, 0, 0, 0,
    0, 12, 13,  15,  17,  17,  15,  14,  12, 0, 0, 0, 0, 0, 0, 0,
    0, 13, 14,  16,  16,  16,  16,  14,  13, 0, 0, 0, 0, 0, 0, 0,
    0, 11, 14,  12,  12,  12,  12,  14,  11, 0, 0, 0, 0, 0, 0, 0,
    0, 13, 10,  10,  10,  10,  10,  10,  13, 0, 0, 0, 0, 0, 0, 0,
    0,  0,  0,   0,   0,   0,   0,   0 
};



Signed2         QueenTable[H8 + 1] =
{
  0,  0,  0,   0,   0,   0,   0,   0,  0,  0, 0, 0, 0, 0, 0, 
  0,  0,  1,   2,   3,   3,   2,   1,  0,  0, 0, 0, 0, 0, 0, 
  0,  8, 10, 11, 12, 12, 11, 10,   8,  0,  0, 0, 0, 0, 0, 0, 
  0,  5,  6,  7,  8,  8,  7,  6,   5,  0,  0, 0, 0, 0, 0, 0, 
  0,  6,  7,  8,  9,  9,  8,  7,   6,  0,  0, 0, 0, 0, 0, 0, 
  0,  8,  9, 10, 11, 11, 10,  9,   8,  0,  0, 0, 0, 0, 0, 0, 
  0, 10, 11, 12, 13, 13, 12, 11,  10,  0,  0, 0, 0, 0, 0, 0, 
  0,  8, 10, 11, 12, 12, 11, 10,   8,  0,  0, 0, 0, 0, 0, 0, 
  0,  5,  6,  7,  8,  8,  7,  6,   5,  0,  0, 0, 0, 0, 0, 0, 
  0,  0,  0,   0,   0,   0,   0,   0,  0  
};


HashType        pawnHashTable[2][H8 + 1];
HashType        knightHashTable[2][H8 + 1];
HashType        bishopHashTable[2][H8 + 1];
HashType        rookHashTable[2][H8 + 1];
HashType        queenHashTable[2][H8 + 1];
HashType        kingHashTable[2][H8 + 1];
HashType        movedHash;
HashType        enPassantHashTable[H + 1];
HashType        castlingHashTable[2][2];

Boolean         printDebug;

char           *version = "24 january 1995";

Unsigned4       nrMovesGenerated,
                nrGenerates;


static void     SetTestingDefaults(Signed2 * testDepth, Signed2 * testColor,
                                                   Signed4 testNrNodes);
static void     SetDefaults(Boolean * useTransTable, Boolean * useRefTable,
                           Unsigned1 * nrTtBits, Boolean * useTwoLevelTable,
                                            Boolean * useTtValue, Boolean * useTtMove, Boolean * timeStamp,
                                            Boolean * useFlag);
static void     PerformTest(Signed2 startingMove, Signed2 testColor,
                                            Signed2 testDepth);


void            TestArguments()
{
    Signed2         i;
    Signed2         testDepth,
                    testColor,
                    startingMove;
    MoveType        move;
    ValueType       value;
    char            s[MaxMoveLength];

    doTest = False;
    testDepth = testColor = -1;
    testNrNodes = -1;
    debugDepth = 0;

	useTransTable    = TransTableDefault;
	useRefTable      = RefTableDefault;
	useTwoLevelTable = TwoLevelTableDefault;
	useTtValue       = TtValueDefault;
	useTtMove        = TtMoveDefault;
    useFlag          = UseFlagDefault;
    timeStamp        = TimeStampDefault;
    if (!hashsize) nrTtBits   = TtBitsDefault;
	else
    nrTtBits = hashsize; 
	
	keepPly          = KeepPlyDefault;
  
    if (new_use)      keepMethod = New;
	else
	if (big1_use)     keepMethod = Big1;
	else
	if (bigall_use)   keepMethod = BigAll;
	else
	if (deep_use)     keepMethod = Deep;
	else
	if (old_use)      keepMethod = Old;

   

    SetDefaults(&useTransTable, &useRefTable, &nrTtBits, &useTwoLevelTable,
                &useTtValue, &useTtMove, &timeStamp, &useFlag);
    PrintSettings();
    if (useTransTable) {
        printf("Initializing transposition table (%lu entries * %d)",
               1L << nrTtBits, sizeof(TtEntry));
        printf(" --> %lu bytes", (1L << nrTtBits) * sizeof(TtEntry));
        fflush(stdout);
        InitTransTable();
        printf("\n");
        if (useTwoLevelTable) { /* 2 positions per entry: hash,
                                 * hash+1<<nrTtBits */
            nrTtBits--;
        }
        if (nrTtBits < (sizeof(TtEntry) <= 16 ? 15 : 7)) {
            printf("\nERROR: nrTtBits must be at least %d.\n",
                   (sizeof(TtEntry) <= 16 ? 15 : 7));
            exit(0);
        }
    }
   
      
    
}                               /* TestArguments */


static void     SetTestingDefaults(Signed2 * testDepth, Signed2 * testColor,
                                                   Signed4 testNrNodes)
{
    if (*testDepth == -1) {
        if (testNrNodes == -1) {
            *testDepth = DepthDefault;
            printf("\nChoosing default depth %d", DepthDefault);
        } else {
            *testDepth = MaxSearchDepth;
        }
    }
    if (*testColor == -1) {
        *testColor = ColorDefault;
        printf("\nChoosing default color %s", moveColorString[ColorDefault]);
    }
    printf("\n");
}                               /* SetTestingDefaults */


static void     SetDefaults(Boolean * useTransTable, Boolean * useRefTable,
                           Unsigned1 * nrTtBits, Boolean * useTwoLevelTable,
                                            Boolean * useTtValue, Boolean * useTtMove, Boolean * timeStamp,
                                            Boolean * useFlag)
{
     
	printf("Choosing default transpo %d\n", *useTransTable);
    printf("Choosing default ref %d\n", *useRefTable);
    printf("Choosing default nrTtBits %d\n", *nrTtBits);
    printf("Choosing default twoLevelTable %d\n", *useTwoLevelTable);
    printf("Choosing default ttValue %d\n", *useTtValue);
    printf("Choosing default ttMove %d\n", *useTtMove);
    printf("Choosing default timeStamp %d\n", *timeStamp);
    printf("Choosing default useFlag %d\n", *useFlag);
    
}                               /* SetDefaults */


static void     PerformTest(Signed2 startingMove, Signed2 testColor,
                                            Signed2 testDepth)
{
    Signed2         startingPly,
                    i;
    Unsigned2       testMaxGamePlies;
    char            testGameString[MaxGamePlies][MaxMoveLength];
    MoveType        testGame[MaxGamePlies];
    Boolean         blackBegin;
    char            s[MaxMoveLength];
    MoveType        move;
    ValueType       value;

    startingPly = (startingMove - 1) * 2;
    if ((toMove == White && nrGamePlies % 2 == 0) ||
        (toMove == Black && nrGamePlies % 2 == 1)) {
        if (testColor == Black) {
            ++startingPly;
        }
        blackBegin = False;
    } else {
        if (testColor == White) {
            --startingPly;
        }
        blackBegin = True;
    }
    if (startingPly < 0 || startingPly >= nrGamePlies) {
        printf("ERROR: Starting move '%d' not possible\n", startingMove);
        exit(0);
    }
    /* Save variables */
    testMaxGamePlies = maxGamePlies;
    for (i = 0; i < testMaxGamePlies; i++) {
        testGame[i] = game[i];
        strcpy(testGameString[i], gameString[i]);
    }
    /* Take moves back */
    for (i = 0; i < maxGamePlies - startingPly; i++) {
        UndoMove();
    }
    /* Calculate the moves */
    for (i = startingPly; i < testMaxGamePlies; i++) {
        if (material[White] <= EndgameMaterial ||
            material[Black] <= EndgameMaterial) {
            printf("Stop: endgame reached\n");
            break;
        }
        if ((i - startingPly) % 2 == 0) {
            if (testColor != toMove) {
                printf("ERROR: wrong search color\n");
                exit(0);
            }
            printf("\nCalculating move %d\n", blackBegin ? (i + 3) / 2 : (i + 2) / 2);
            Search((Signed1) testDepth, &move, &value);
            if (move.from) {
                SPrintMove(s, move);
                printf("My move: %s\n", s);
            }
        }
        DoMove(&(testGame[i]));
        printf("Forward: %s\n", testGameString[i]);
    }
}                               /* PerformTest */



/*----------------------------------------------------------------------
 | INIT							940420
 |
 | Contains procedures concerning the initialization of several
 | variables.
 +----------------------------------------------------------------------*/



static void     InitMoveTables(void);
static void     InitKnightTable(void);
static void     InitBishopTable(void);
static void     InitRookTable(void);
static void     InitPawnMoveTables(void);
static void     InitPawnCaptureTables(void);
static void     InitPieceSymbols(void);
static void     InitPieceValues(void);
static void     InitAllocVariables(void);
static void     FillHashTables(void);
static void     InitPackArrays(void);
static void     UpdateCentreTable(void);
static Boolean  Unique(HashType h);
static void     CheckHashTables(void);


/*----------------------------------------------------------------------
 | Init								940421
 |
 | Initializes the move tables, piece symbols, piece values,
 | alloc variables, piece tables, history tables, transposition table.
 | Puts board in starting position.
 +----------------------------------------------------------------------*/
void            Init(void)
{
    FillHashTables();
    CheckHashTables();
    EmptyBoard();               /* Has to be done before InitMoveTables! */
    InitMoveTables();
    InitPieceSymbols();
    InitPieceValues();
    InitAllocVariables();
    StartingPosition();
    InitPackArrays();
    UpdateCentreTable();
}                               /* Init */


/*----------------------------------------------------------------------
 | InitMoveTables						940421
 |
 | Initializes all move tables.
 +----------------------------------------------------------------------*/
void            InitMoveTables(void)
{
    InitKnightTable();
    InitBishopTable();
    InitRookTable();
    InitPawnMoveTables();
    InitPawnCaptureTables();
}                               /* InitMoveTables */


/*----------------------------------------------------------------------
 | InitKnightTable						940422
 |
 | Initializes the knight move table.
 +----------------------------------------------------------------------*/
void            InitKnightTable(void)
{
    Signed2         i,
                    j,
                    d,
                    nr;
    BoardIndexType  from,
                    to;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < MaxKnightMoves; j++) {
            knightTable[i][j] = 0;
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            from = Square(i, j);
            nr = 0;
            for (d = 0; d < 8; d++) {
                to = from + knightDir[d];
                if (IsEmpty(board[to])) {
                    knightTable[from][nr++] = to;
                }
            }                   /* for d */
        }                       /* for j */
    }                           /* for i */
}                               /* InitKnightTable */


/*----------------------------------------------------------------------
 | InitBishopTable						940422
 |
 | Initializes the bishop move table.
 +----------------------------------------------------------------------*/
void            InitBishopTable(void)
{
    Signed2         i,
                    j,
                    d,
                    nr;
    BoardIndexType  from,
                    to;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < MaxBishopMoves; j++) {
            for (d = 0; d < 4; d++) {
                bishopTable[i][d][j] = 0;
            }
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            from = Square(i, j);
            for (d = 0; d < 4; d++) {
                nr = 0;
                for (to = from + bishopDir[d]; IsEmpty(board[to]);
                     to += bishopDir[d]) {
                    bishopTable[from][d][nr++] = to;
                }
            }                   /* for d */
        }                       /* for j */
    }                           /* for i */
}                               /* InitBishopTable */


/*----------------------------------------------------------------------
 | InitRookTable						940422
 |
 | Initializes the rook move table.
 +----------------------------------------------------------------------*/
void            InitRookTable(void)
{
    Signed2         i,
                    j,
                    d,
                    nr;
    BoardIndexType  from,
                    to;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < MaxRookMoves; j++) {
            for (d = 0; d < 4; d++) {
                rookTable[i][d][j] = 0;
            }
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            from = Square(i, j);
            for (d = 0; d < 4; d++) {
                nr = 0;
                for (to = from + rookDir[d]; IsEmpty(board[to]);
                     to += rookDir[d]) {
                    rookTable[from][d][nr++] = to;
                }
            }                   /* for d */
        }                       /* for j */
    }                           /* for i */
}                               /* InitRookTable */


/*----------------------------------------------------------------------
 | InitPawnMoveTables						940422
 |
 | Initializes the pawn movetables.
 +----------------------------------------------------------------------*/
void            InitPawnMoveTables(void)
{
    Signed2         i,
                    j;
    BoardIndexType  from;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < 2; j++) {
            pawnMoveTable[White][i][j] = 0;
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 7; j++) {
            from = Square(i, j);
            if (j == 2) {
                pawnMoveTable[White][from][1] = from + Up + Up;
            }
            pawnMoveTable[White][from][0] = from + Up;
        }                       /* for j */
    }                           /* for i */

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < 2; j++) {
            pawnMoveTable[Black][i][j] = 0;
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 2; j <= 8; j++) {
            from = Square(i, j);
            if (j == 7) {
                pawnMoveTable[Black][from][1] = from + Down + Down;
            }
            pawnMoveTable[Black][from][0] = from + Down;
        }                       /* for j */
    }                           /* for i */
}                               /* InitPawnMoveTables */


/*----------------------------------------------------------------------
 | InitPawnCaptureTables					940422
 |
 | Initializes the pawn capture tables.
 +----------------------------------------------------------------------*/
void            InitPawnCaptureTables(void)
{
    Signed2         i,
                    j,
                    k;
    BoardIndexType  from,
                    to;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < 2; j++) {
            pawnCaptureTable[White][i][j] = 0;
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 7; j++) {
            from = Square(i, j);
            for (k = 0; k < 2; k++) {
                to = from + pawnCaptureDir[White][k];
                if (IsEmpty(board[to])) {
                    pawnCaptureTable[White][from][k] = to;
                } else {
                    pawnCaptureTable[White][from][k] = 0;
                }
            }
        }                       /* for j */
    }                           /* for i */

    for (i = 0; i <= H8; i++) {
        for (j = 0; j < 2; j++) {
            pawnCaptureTable[Black][i][j] = 0;
        }
    }
    for (i = A; i <= H; i++) {
        for (j = 2; j <= 8; j++) {
            from = Square(i, j);
            for (k = 0; k < 2; k++) {
                to = from + pawnCaptureDir[Black][k];
                if (IsEmpty(board[to])) {
                    pawnCaptureTable[Black][from][k] = to;
                } else {
                    pawnCaptureTable[Black][from][k] = 0;
                }
            }
        }                       /* for j */
    }                           /* for i */
}                               /* InitPawnCaptureTables */


/*----------------------------------------------------------------------
 | InitPieceSymbols						940421
 |
 | Initializes all piece symbols. White pieces in capitals.
 +----------------------------------------------------------------------*/
static void     InitPieceSymbols(void)
{
    Signed2         i;

    for (i = 0; i < 256; i++) {
        pieceSymbol[i] = '#';
    }
	
	pieceSymbol[WhitePawn] = ' ';
	pieceSymbol[WhiteKnight] = ' ';
	pieceSymbol[WhiteBishop] = ' ';
	pieceSymbol[WhiteRook] = ' ';
	pieceSymbol[WhiteQueen] = ' ';
	pieceSymbol[WhiteKing] = ' ';
	pieceSymbol[BlackPawn] = ' ';
	pieceSymbol[BlackKnight] = ' ';
	pieceSymbol[BlackBishop] = ' ';
	pieceSymbol[BlackRook] = ' ';
	pieceSymbol[BlackQueen] = ' ';
	pieceSymbol[BlackKing] = ' ';

    

}                               /* InitPieceSymbols */


/*----------------------------------------------------------------------
 | InitPieceValues.						940425
 |
 | Initializes all piece values.
 +----------------------------------------------------------------------*/
static void     InitPieceValues(void)
{
    Signed2         i;

    for (i = 0; i < 128; i++) {
        pieceValue[i] = 0;
    }
    pieceValue[WhitePawn]   = value_pawn;
    pieceValue[BlackPawn]   = value_pawn;
    pieceValue[WhiteKnight] = value_knight;
    pieceValue[BlackKnight] = value_knight;
    pieceValue[WhiteBishop] = value_bishop;
    pieceValue[BlackBishop] = value_bishop;
    pieceValue[WhiteRook]   = value_rook;
    pieceValue[BlackRook]   = value_rook;
    pieceValue[WhiteQueen]  = value_queen;
    pieceValue[BlackQueen]  = value_queen;
    pieceValue[WhiteKing]   = value_king;
    pieceValue[BlackKing]   = value_king;
    
}                               /* InitPieceValues */


/*----------------------------------------------------------------------
 | InitAllocVariables.						940425
 |
 | Initializes all allocation variables. They are used to check if
 | all allocated memory is being freed.
 +----------------------------------------------------------------------*/
static void     InitAllocVariables(void)
{
    nrAllocMoveLists = nrAllocPathMoves = 0;
}                               /* InitAllocVariables */


/*----------------------------------------------------------------------
 | EmptyBoard							940421
 |
 | Empties the board and resets number of black and white pieces.
 | Furthermnore, the history tables are cleared.
 +----------------------------------------------------------------------*/
void            EmptyBoard(void)
{
    BoardIndexType  i,
                    j;

    for (i = 0; i < NrSquares; i++) {
        board[i] = Edge;
    }
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            board[Square(i, j)] = Empty;
        }
    }
    nrPieces[White] = nrPieces[Black] = 0;
    toMove = White;
    for (i = A1; i <= H8; i++) {
        pieceIndex[i] = 0;
    }
    kingSquare[White] = kingSquare[Black] = 0;
    nrGamePlies = maxGamePlies = 0;
    epSquare[nrGamePlies] = NoEp;
    castling[nrGamePlies] = 0;
    material[White] = material[Black] = 0;
    HashMakeZero(hashValue[nrGamePlies]);
    startHashIndex[nrGamePlies] = nrGamePlies;
    InitPositionalValue();

    ClearHistoryTables();
    lastMovedPieceSquare = 0;
}                               /* EmptyBoard */


/*----------------------------------------------------------------------
 | StartingPosition						940421
 |
 | Places all pieces on an empty board in starting position.
 +----------------------------------------------------------------------*/
void            StartingPosition(void)
{
    PlacePiece((SquareType) WhiteKnight, (BoardIndexType) B1);
    PlacePiece((SquareType) WhiteKnight, (BoardIndexType) G1);
    PlacePiece((SquareType) WhiteBishop, (BoardIndexType) C1);
    PlacePiece((SquareType) WhiteBishop, (BoardIndexType) F1);
    PlacePiece((SquareType) WhiteRook, (BoardIndexType) A1);
    PlacePiece((SquareType) WhiteRook, (BoardIndexType) H1);
    PlacePiece((SquareType) WhiteQueen, (BoardIndexType) D1);
    PlacePiece((SquareType) WhiteKing, (BoardIndexType) E1);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) A2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) B2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) C2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) D2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) E2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) F2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) G2);
    PlacePiece((SquareType) WhitePawn, (BoardIndexType) H2);

    PlacePiece((SquareType) BlackKnight, (BoardIndexType) B8);
    PlacePiece((SquareType) BlackKnight, (BoardIndexType) G8);
    PlacePiece((SquareType) BlackBishop, (BoardIndexType) C8);
    PlacePiece((SquareType) BlackBishop, (BoardIndexType) F8);
    PlacePiece((SquareType) BlackRook, (BoardIndexType) A8);
    PlacePiece((SquareType) BlackRook, (BoardIndexType) H8);
    PlacePiece((SquareType) BlackQueen, (BoardIndexType) D8);
    PlacePiece((SquareType) BlackKing, (BoardIndexType) E8);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) A7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) B7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) C7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) D7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) E7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) F7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) G7);
    PlacePiece((SquareType) BlackPawn, (BoardIndexType) H7);

    castling[nrGamePlies] = WhiteShort | WhiteLong | BlackShort | BlackLong;
    HashXorIs(hashValue[nrGamePlies], castlingHashTable[White][Short]);
    HashXorIs(hashValue[nrGamePlies], castlingHashTable[White][Long]);
    HashXorIs(hashValue[nrGamePlies], castlingHashTable[Black][Short]);
    HashXorIs(hashValue[nrGamePlies], castlingHashTable[Black][Long]);
}                               /* StartingPosition */


/*----------------------------------------------------------------------
 | PlacePiece							940421
 |
 | Puts a piece on the board. Updates the board and the piece tables.
 +----------------------------------------------------------------------*/
void            PlacePiece(SquareType piece, BoardIndexType square)
{
    SquareType      color;
    HashType       *table;

    board[square] = piece;
    color = Color(piece);
    pieces[color][nrPieces[color]].type = piece;
    pieces[color][nrPieces[color]].square = square;
    pieceIndex[square] = nrPieces[color]++;
    if (IsKing(piece)) {
        kingSquare[color] = square;
    }
    material[color] += pieceValue[piece];

	if (move_count > 30 && !endgame_values) {
   if (material[White] <= EndgameMaterial ||
            material[Black] <= EndgameMaterial) {
           
			printf("\n[AliBaba] endgame reached\n");
			printf("[AliBaba] setting new piece values\n");
			
          /* endgame piece values */

value_pawn    =   value_pawn   + 80;  /* pawns more valuable in endgame */
value_knight  =   value_knight + 20;       
value_bishop  =   value_bishop + 20;         
value_rook    =   value_rook   + 20;
value_queen   =   value_queen  + 20;
value_king    =   400;   /* GM Max Euwe's calculation of king value in endgame */    

InitPieceValues();
endgame_values = true;
        }
   
	}

    GetHashTable(table, color, piece);
    HashXorIs(hashValue[nrGamePlies], table[square]);
}                               /* PlacePiece */


/*----------------------------------------------------------------------
 | ClearHistoryTables.						940606
 |
 | Clears the white and black history tables.
 +----------------------------------------------------------------------*/
void            ClearHistoryTables(void)
{
    BoardIndexType  i,
                    j;

    for (i = 0; i <= H8; i++) {
        for (j = 0; j <= H8; j++) {
            historyTable[White][i][j] = historyTable[Black][i][j] = 0;
        }
    }
}                               /* ClearHistoryTables */


/*----------------------------------------------------------------------
 | ClearPieceSquareTables.					940606
 |
 | Clears the white and black piece-square tables.
 +----------------------------------------------------------------------*/
void            ClearPieceSquareTables(void)
{
    BoardIndexType  i;

    for (i = 0; i <= H8; i++) {
        pawnEvalTable[White][i] = pawnEvalTable[Black][i] = 0;
        knightEvalTable[White][i] = knightEvalTable[Black][i] = 0;
        bishopEvalTable[White][i] = bishopEvalTable[Black][i] = 0;
        rookEvalTable[White][i] = rookEvalTable[Black][i] = 0;
        queenEvalTable[White][i] = queenEvalTable[Black][i] = 0;
        kingEvalTable[White][i] = kingEvalTable[Black][i] = 0;
    }
}                               /* ClearPieceSquareTables */


void            InitPositionalValue(void)
{
    Signed2        *table;
    Signed2         i;

    positionalValue[White] = 0;
    for (i = 0; i < nrPieces[White]; i++) {
        GetEvalTable(table, White, pieces[White][i].type);
        positionalValue[White] += table[pieces[White][i].square];
    }
    printf("\n");
    positionalValue[Black] = 0;
    for (i = 0; i < nrPieces[Black]; i++) {
        GetEvalTable(table, Black, pieces[Black][i].type);
        positionalValue[Black] += table[pieces[Black][i].square];
    }
}                               /* InitPositionalValue */

static void     reverse(HashType h)
{
    Unsigned1       b1,
                    b2,
                    b3,
                    b4;

    b1 = h[0] & 255;
    b2 = (h[0] >> 8) & 255;
    b3 = (h[0] >> 16) & 255;
    b4 = (h[0] >> 24) & 255;
    h[0] = (b1 << 24) | (b2 << 16) | (b3 << 8) | b4;
    b1 = h[1] & 255;
    b2 = (h[1] >> 8) & 255;
    b3 = (h[1] >> 16) & 255;
    b4 = (h[1] >> 24) & 255;
    h[1] = (b1 << 24) | (b2 << 16) | (b3 << 8) | b4;
}

static void     FillHashTables(void)
{
    Signed2         i,
                    j;
    BoardIndexType  square;
    FILE           *fp;

    if ((fp = fopen("random.tab", "rb")) != NULL) {
        printf("\nReading random values from 'random.tab'\n");
        fread(pawnHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(pawnHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(knightHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(knightHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(bishopHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(bishopHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(rookHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(rookHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(queenHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(queenHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(kingHashTable[White], sizeof(HashType), H8 + 1, fp);
        fread(kingHashTable[Black], sizeof(HashType), H8 + 1, fp);
        fread(enPassantHashTable, sizeof(HashType), H + 1, fp);
        fread(movedHash, sizeof(HashType), 1, fp);
        fread(castlingHashTable[White], sizeof(HashType), 2, fp);
        fread(castlingHashTable[Black], sizeof(HashType), 2, fp);
        fclose(fp);
    } else {
        srand48((unsigned)time(NULL));
        for (i = A; i <= H; i++) {
            for (j = 1; j <= 8; j++) {
                square = Square(i, j);
                SetRandomHash(pawnHashTable[White][square]);
                SetRandomHash(pawnHashTable[Black][square]);
                SetRandomHash(knightHashTable[White][square]);
                SetRandomHash(knightHashTable[Black][square]);
                SetRandomHash(bishopHashTable[White][square]);
                SetRandomHash(bishopHashTable[Black][square]);
                SetRandomHash(rookHashTable[White][square]);
                SetRandomHash(rookHashTable[Black][square]);
                SetRandomHash(queenHashTable[White][square]);
                SetRandomHash(queenHashTable[Black][square]);
                SetRandomHash(kingHashTable[White][square]);
                SetRandomHash(kingHashTable[Black][square]);
            }
            SetRandomHash(enPassantHashTable[i]);
        }
        SetRandomHash(movedHash);
        SetRandomHash(castlingHashTable[White][Short]);
        SetRandomHash(castlingHashTable[White][Long]);
        SetRandomHash(castlingHashTable[Black][Short]);
        SetRandomHash(castlingHashTable[Black][Long]);

        if ((fp = fopen("random.tab", "wb")) != NULL) {
            fwrite(pawnHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(pawnHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(knightHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(knightHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(bishopHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(bishopHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(rookHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(rookHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(queenHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(queenHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(kingHashTable[White], sizeof(HashType), H8 + 1, fp);
            fwrite(kingHashTable[Black], sizeof(HashType), H8 + 1, fp);
            fwrite(enPassantHashTable, sizeof(HashType), H + 1, fp);
            fwrite(movedHash, sizeof(HashType), 1, fp);
            fwrite(castlingHashTable[White], sizeof(HashType), 2, fp);
            fwrite(castlingHashTable[Black], sizeof(HashType), 2, fp);
            fclose(fp);
        }
    }                          
 }



void            InitTransTable(void)
{
    Unsigned4       i;

    Malloc(transTable, TtEntry, 1L << nrTtBits);
    for (i = 0; i < (1L << nrTtBits); i++) {
        ClearEntry(&(transTable[i]));
    }
}                               /* InitTransTable */


static void     InitPackArrays(void)
{
    Signed2         i,
                    file,
                    rank,
                    piece;

    /* Initialize packPiece and unpackPiece */
    for (piece = 0; piece < Edge; piece++) {
        if (IsKnight(piece)) {
            packPiece[piece] = PackKnight;
        } else if (IsBishop(piece)) {
            packPiece[piece] = PackBishop;
        } else if (IsRook(piece)) {
            packPiece[piece] = PackRook;
        } else if (IsQueen(piece)) {
            packPiece[piece] = PackQueen;
        } else {
            packPiece[piece] = 0;
        }
    }
    unpackPiece[PackKnight] = Knight;
    unpackPiece[PackBishop] = Bishop;
    unpackPiece[PackRook] = Rook;
    unpackPiece[PackQueen] = Queen;

    /* Initialize packSquare and unpackSquare */
    for (i = 0; i <= H8; i++) {
        packSquare[i] = 0;
    }
    for (file = A; file <= H; file++) {
        for (rank = 1; rank <= 8; rank++) {
            packSquare[Square(file, rank)] = (file - A) * 8 + rank - 1;
            unpackSquare[(file - A) * 8 + rank - 1] = Square(file, rank);
        }
    }

    /* Initialize packType and unpackType */
    for (i = 0; i <= 63; i++) {
        packType[i] = 0;
    }
    packType[Normal] = PackNormal;
    packType[Double] = PackDouble;
    packType[ShortCastle] = PackShortCastle;
    packType[LongCastle] = PackLongCastle;
    packType[EnPassant | Capture] = PackEnPassant;
    packType[Capture] = PackCapture;
    packType[Promotion] = PackPromotion;
    packType[Promotion | Capture] = PackCapPromotion;
    unpackType[PackNormal] = Normal;
    unpackType[PackDouble] = Double;
    unpackType[PackShortCastle] = ShortCastle;
    unpackType[PackLongCastle] = LongCastle;
    unpackType[PackEnPassant] = EnPassant | Capture;
    unpackType[PackCapture] = Capture;
    unpackType[PackPromotion] = Promotion;
    unpackType[PackCapPromotion] = Promotion | Capture;
}                               /* InitPackArrays */


static void     UpdateCentreTable(void)
{
    Signed2         i;

    for (i = 0; i <= H8; i++) {
        centreTable[i] /= 1000 / pieceValue[WhitePawn];
    }
}                               /* UpdateCentreTable */


static void     CheckHashTables(void)
{
    Signed2         i,
                    j;
    BoardIndexType  square;
    char            s[4];

    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            square = Square(i, j);
            SPrintSquare(s, square);
            if (!Unique(pawnHashTable[White][square])) {
                printf("ERROR: pawnHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(pawnHashTable[Black][square])) {
                printf("ERROR: pawnHashTable[ Black ][ %s ] not unique\n", s);
            }
            if (!Unique(knightHashTable[White][square])) {
                printf("ERROR: knightHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(knightHashTable[Black][square])) {
                printf("ERROR: knightHashTable[ Black ][ %s ] not unique\n", s);
            }
            if (!Unique(bishopHashTable[White][square])) {
                printf("ERROR: bishopHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(bishopHashTable[Black][square])) {
                printf("ERROR: bishopHashTable[ Black ][ %s ] not unique\n", s);
            }
            if (!Unique(rookHashTable[White][square])) {
                printf("ERROR: rookHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(rookHashTable[Black][square])) {
                printf("ERROR: rookHashTable[ Black ][ %s ] not unique\n", s);
            }
            if (!Unique(queenHashTable[White][square])) {
                printf("ERROR: queenHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(queenHashTable[Black][square])) {
                printf("ERROR: queenHashTable[ Black ][ %s ] not unique\n", s);
            }
            if (!Unique(kingHashTable[White][square])) {
                printf("ERROR: kingHashTable[ White ][ %s ] not unique\n", s);
            }
            if (!Unique(kingHashTable[Black][square])) {
                printf("ERROR: kingHashTable[ Black ][ %s ] not unique\n", s);
            }
        }                       /* for j */
        if (!Unique(enPassantHashTable[i])) {
            printf("ERROR: enPassantHashTable[ %c ] not unique\n", i - A + 'A');
        }
    }                           /* for i */
    if (!Unique(movedHash)) {
        printf("ERROR: movedHash not unique\n");
    }
    for (i = 0; i < 2; i++) {
        if (!Unique(castlingHashTable[White][i])) {
            printf("ERROR: castlingHashTable[ White ][ %d ] not unique\n", i);
        }
        if (!Unique(castlingHashTable[Black][i])) {
            printf("ERROR: castlingHashTable[ Black ][ %d ] not unique\n", i);
        }
    }
}                               /* CheckHashTables */


static          Boolean
                Unique(HashType h)
{
    Signed2         i,
                    j;
    BoardIndexType  square;
    Unsigned2       nr;

    if (h[0] == 0 && h[1] == 0) {
        return (False);
    }
    nr = 0;
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            square = Square(i, j);
            if (HashEqual(pawnHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(pawnHashTable[Black][square], h)) {
                nr++;
            }
            if (HashEqual(knightHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(knightHashTable[Black][square], h)) {
                nr++;
            }
            if (HashEqual(bishopHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(bishopHashTable[Black][square], h)) {
                nr++;
            }
            if (HashEqual(rookHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(rookHashTable[Black][square], h)) {
                nr++;
            }
            if (HashEqual(queenHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(queenHashTable[Black][square], h)) {
                nr++;
            }
            if (HashEqual(kingHashTable[White][square], h)) {
                nr++;
            }
            if (HashEqual(kingHashTable[Black][square], h)) {
                nr++;
            }
        }                       /* for j */
        if (HashEqual(enPassantHashTable[i], h)) {
            nr++;
        }
    }                           /* for i */
    if (HashEqual(movedHash, h)) {
        nr++;
    }
    for (i = 0; i < 2; i++) {
        if (HashEqual(castlingHashTable[White][i], h)) {
            nr++;
        }
        if (HashEqual(castlingHashTable[Black][i], h)) {
            nr++;
        }
    }
#ifdef _DEBUG
	if (nr != 1)
	    printf("number = %d\n", nr);
#endif
    return (nr == 1);
}                               /* Unique */



////////////////////////// srand48  /////////////////////////


/*
 * Copyright (c) 1993 Martin Birgmeier
 * All rights reserved.
 *
 * You may redistribute unmodified or modified versions of this source
 * code provided that the above copyright notice and this and the
 * following conditions are retained.
 *
 * This software is provided ``as is'', and comes with no warranties
 * of any kind. I shall in no event be liable for anything that happens
 * to anyone/anything when using this software.
 */


extern unsigned short _rand48_seed[3];
extern unsigned short _rand48_mult[3];
extern unsigned short _rand48_add;

void
srand48(long seed)
{
	_rand48_seed[0] = RAND48_SEED_0;
	_rand48_seed[1] = (unsigned short) seed;
	_rand48_seed[2] = (unsigned short) (seed >> 16);
	_rand48_mult[0] = RAND48_MULT_0;
	_rand48_mult[1] = RAND48_MULT_1;
	_rand48_mult[2] = RAND48_MULT_2;
	_rand48_add = RAND48_ADD;
}


/////////////////////// Drand48 //////////////////////

/*
 * Copyright (c) 1993 Martin Birgmeier
 * All rights reserved.
 *
 * You may redistribute unmodified or modified versions of this source
 * code provided that the above copyright notice and this and the
 * following conditions are retained.
 *
 * This software is provided ``as is'', and comes with no warranties
 * of any kind. I shall in no event be liable for anything that happens
 * to anyone/anything when using this software.
 */


extern unsigned short _rand48_seed[3];

double
drand48(void)
{
	return erand48(_rand48_seed);
}



///////////////////// erand48  ////////////////////////


/*
 * Copyright (c) 1993 Martin Birgmeier
 * All rights reserved.
 *
 * You may redistribute unmodified or modified versions of this source
 * code provided that the above copyright notice and this and the
 * following conditions are retained.
 *
 * This software is provided ``as is'', and comes with no warranties
 * of any kind. I shall in no event be liable for anything that happens
 * to anyone/anything when using this software.
 */


double
erand48(unsigned short xseed[3])
{
	_dorand48(xseed);
	return ldexp((double) xseed[0], -48) +
	       ldexp((double) xseed[1], -32) +
	       ldexp((double) xseed[2], -16);
}



///////////////////////////  _rand48 //////////////


/*
 * Copyright (c) 1993 Martin Birgmeier
 * All rights reserved.
 *
 * You may redistribute unmodified or modified versions of this source
 * code provided that the above copyright notice and this and the
 * following conditions are retained.
 *
 * This software is provided ``as is'', and comes with no warranties
 * of any kind. I shall in no event be liable for anything that happens
 * to anyone/anything when using this software.
 */



unsigned short _rand48_seed[3] = {
	RAND48_SEED_0,
	RAND48_SEED_1,
	RAND48_SEED_2
};
unsigned short _rand48_mult[3] = {
	RAND48_MULT_0,
	RAND48_MULT_1,
	RAND48_MULT_2
};
unsigned short _rand48_add = RAND48_ADD;

void
_dorand48(unsigned short xseed[3])
{
	unsigned long accu;
	unsigned short temp[2];

	accu = (unsigned long) _rand48_mult[0] * (unsigned long) xseed[0] +
	 (unsigned long) _rand48_add;
	temp[0] = (unsigned short) accu;	/* lower 16 bits */
	accu >>= sizeof(unsigned short) * 8;
	accu += (unsigned long) _rand48_mult[0] * (unsigned long) xseed[1] +
	 (unsigned long) _rand48_mult[1] * (unsigned long) xseed[0];
	temp[1] = (unsigned short) accu;	/* middle 16 bits */
	accu >>= sizeof(unsigned short) * 8;
	accu += _rand48_mult[0] * xseed[2] + _rand48_mult[1] * xseed[1] + _rand48_mult[2] * xseed[0];
	xseed[0] = temp[0];
	xseed[1] = temp[1];
	xseed[2] = (unsigned short) accu;
}



/*----------------------------------------------------------------------
 | AB 							940426
 |
 | Contains all ab-search functions.
 +----------------------------------------------------------------------*/

static ValueType Ab(Signed1 depth, ValueType alpha, ValueType beta,
                                    PathType ** bestPath);
static void     PutMoveInFront(MoveType * moveList, Unsigned1 nrMoves,
                                               MoveType * ttMove);
static double   PercFilled(void);
static Unsigned4 NrFilled(void);
static Unsigned4 ExpectedCollisions(Unsigned4 nodes);


/*----------------------------------------------------------------------
 | Search							940426
 |
 | Search for the best move at the root of the tree.
 +----------------------------------------------------------------------*/
void            Search(Signed1 searchDepth, MoveType * move, ValueType * bestValue)
{
    Unsigned1       nrMoves;
    MoveType       *moveList,
                    tempMove;
    ValueType       value,
                    alfa,
                    beta;
    Signed2         i,
                    j;
    Unsigned4       count,
                    ttNodes={0},
                    tot;
    Signed1         depth;
    double          timeUsed;
    Boolean         printDepth;
    PathType       *mainLine[MaxMoves],
                  *tempPath;
    Signed1         ttDepth={0};
    Unsigned1       flag;
    MoveType        ttMove;
    ValueType       ttValue;
    char  s[MaxMoveLength + 1];

    start_time = get_ms();
	stop_time = start_time + maxtime;

    nrGenerates = nrMovesGenerated = 0;
    printDebug = False;
    
	if (!Stop_Search) {
	stopSearching = False;
	}else{
    stopSearching = True;
	}
	StartTime();
  
    computer = toMove;
	
    for (i = 0; i < MaxMoves; i++) {
        mainLine[i] = NULL;
    }
    nrInternalNodes = nrLeafNodes = nrQuiesNodes = 0;
    nrTotalNodes = nrExtraNodes = 0;
    nrCollisions = nrHits = nrReads = nrWrites = 0;
    nrIllegalMoves = 0;
    if (searchDepth == 0) {
        PreProcessing();
        value = Quiescence(-Infinity, Infinity, &(mainLine[0]), -2, 0, 0, 0);
        
        PrintSearchInfo( 0, value, timeUsed, mainLine[0]);
        FreePath(mainLine[0]);
        move->from = 0;
        return;
    }
    if (searchDepth > MaxSearchDepth) {
        searchDepth = MaxSearchDepth;
    }
    startPly = nrGamePlies;
    if (startPly > 255) {
        printf("Warning: startPly too big!\n");
        startPly = 255;
    }
    /* Clear transposition tables */
    if (useTransTable && !timeStamp) {
        tot = useTwoLevelTable ? 1L << (nrTtBits + 1) : 1L << nrTtBits;
        for (count = 0; count < tot; count++) {
            if (GetFlag(&(transTable[count])) != NoEntry &&
                GetPly(&(transTable[count])) + keepPly < nrGamePlies) {
                ClearEntry(&(transTable[count]));
            }
        }
    }
    if (useTransTable) {
        printf("[%lu positions remaining in transposition table]\n", NrFilled());
    }
    ClearHistoryTables();
    PreProcessing();
    GenerateMoves(&moveList, &nrMoves);
    if (nrMoves == 0) {
        if (Attacked(kingSquare[toMove], (SquareType) ! toMove)) {
            printf("[Alibaba] Mate\n");
			printf("computer mates\n");
			Stop_Search = true;
			computer = Empty;
        } else {
            printf("[Alibaba] Stalemate\n");
			printf("game is a draw\n");
			Stop_Search = true;
            computer = Empty;
        }
        move->from = 0;
        return;
    }
    HeapSort(moveList, nrMoves);
    GetMoveFromTransTable(ttMove, ttDepth, ttValue, flag, ttNodes);
    if (ttDepth != -1 && IsIllegal(ttMove)) {
        SPrintMove(s, ttMove);
        printf("Illegal move %s\n", s);
        ttDepth = -1;
        nrIllegalMoves++;
    }
    if (useTtMove && ttDepth != -1) {
        PutMoveInFront(moveList, nrMoves, &ttMove);
    }
    for (i = 0; i < nrMoves; i++) {
        AllocatePathMove(mainLine[i]);
        SPrintMove(mainLine[i]->moveString, moveList[i]);
        mainLine[i]->move = moveList[i];
    }
    for (depth = 1; depth <= searchDepth; depth++) {
        ++nrInternalNodes;
		
		if (++nrTotalNodes - nrExtraNodes >= testNrNodes && testNrNodes != -1 ||
			
			get_ms() >= stop_time

			) {
            stopSearching = True;
            break;
        }
        for (i = 0; i < nrMoves; i++) {
         //   if (interActive) {
           //     printf("%s (%2d/%2d)\r", mainLine[i]->moveString, i + 1, nrMoves);
             //   fflush(stdout);
           // }
            DoMove(&(moveList[i]));
            if (i == 0) {       /* first move: aspiration search */
                if (depth == 1) {
                    alfa = -Infinity;
                    beta = Infinity;
                } else {        /* depth > 1 */
                    alfa = *bestValue - pieceValue[WhitePawn];
                    beta = *bestValue + pieceValue[WhitePawn];
                }
                value = -Ab(depth - 1, -beta, -alfa, &(mainLine[i]->next));
                if (value >= beta && !stopSearching) {  /* Fail high */
                    PrintSearchInfo(depth, Infinity, timeUsed,  mainLine[i]);
                    *bestValue = -Ab(depth - 1, -Infinity, -value,
                                     &(mainLine[i]->next));
                    printDepth = False;
                } else if (value <= alfa && !stopSearching) {   /* Fail low */
                    PrintSearchInfo(depth, Infinity, timeUsed,  mainLine[i]);
                    *bestValue = -Ab(depth - 1, -value, Infinity, &(mainLine[i]->next));
                    printDepth = False;
                } else {        /* Na fail high or low */
                    if (!stopSearching) {
                        *bestValue = value;
                    } else if (depth == 1) {
                        *bestValue = 0; /* Unknown best value */
                    }
                    printDepth = True;
                }
                if (printDepth) {
                    PrintSearchInfo(depth, *bestValue, timeUsed, mainLine[0]);
                } else {
                    PrintSearchInfo(0, *bestValue,timeUsed, mainLine[0]);
                }
            } else {            /* rest of the moves: zero window */
                value = -Ab(depth - 1, -*bestValue - 1, -*bestValue,
                            &(mainLine[i]->next));
                if (value > *bestValue && !stopSearching) {     /* Fail high */
                    PrintSearchInfo(0, Infinity, timeUsed, mainLine[i]);
                    *bestValue = -Ab(depth - 1, -Infinity, -value,
                                     &(mainLine[i]->next));
                    tempMove = moveList[i];
                    tempPath = mainLine[i];
                    for (j = i; j > 0; j--) {
                        moveList[j] = moveList[j - 1];
                        mainLine[j] = mainLine[j - 1];
                    }
                    moveList[0] = tempMove;
                    mainLine[0] = tempPath;
                    PrintSearchInfo(0, *bestValue, timeUsed, mainLine[0]);
                }               /* if fail high */
            }                   /* rest of the moves */
            UndoMove();
            if (stopSearching) {
                break;
            }
            if (*bestValue == Mate - depth) {   /* Shortest mate found */
                printf("--> Shortest mate found, stop searching\n");
                stopSearching = True;
                break;
            }
        }                       /* for move */
        StopTime(timeUsed);
    //    printf("====================[ %.2f ]====================\n", timeUsed);
        if (!IsCaptureMove(moveList[0].type)) {
            historyTable[toMove][moveList[0].from][moveList[0].to] +=
                1 << depth;
        }
        if (*bestValue <= -MateValue) { /* Best value loses */
            printf("--> Best value loses, stop searching\n");
            depth++;
            break;
        }
        if (stopSearching) {
            depth++;
            break;
        }
    }                           /* for depth */
    *move = moveList[0];
    FreeMoveList(moveList);
    for (i = 0; i < MaxMoves; i++) {
        FreePath(mainLine[i]);
    }
    nrTotalNodes -= nrExtraNodes;       /* When using BigAll */
    printf("%lu nodes (int:%lu, leaf:%lu, quies:%lu), %lu n/s\n",
           nrTotalNodes, nrInternalNodes, nrLeafNodes, nrQuiesNodes,
           (nrTotalNodes == 0 || timeUsed == 0) ? 0 :
           (Unsigned4) (nrTotalNodes / timeUsed));
    if (useTransTable) {
        PutMoveInTransTable(*move, depth - 1, *bestValue, Valid,
                            nrTotalNodes + nrExtraNodes);
        printf("%lu filled (%5.2f%%), %lu reads, %lu hits (%5.2f%%) %lu writes\n",
        NrFilled(), PercFilled(), nrReads, nrHits, nrHits * 100.0 / nrReads,
               nrWrites);
      //  printf("%lu collisions, %lu expected\n", nrCollisions,
          //     ExpectedCollisions(NrFilled() + nrCollisions));
        if (nrIllegalMoves != 0) {
            printf("ERROR: %d illegal moves\n", nrIllegalMoves);
        }
    }
    printf("%lu moves in %lu times (%5.2f)\n", nrMovesGenerated, nrGenerates,
           nrMovesGenerated * 1.0 / nrGenerates);
}                               /* Search */


/*----------------------------------------------------------------------
 | Ab								940502
 |
 | This is the recursive alpha-beta search procedure.
 +----------------------------------------------------------------------*/
static          ValueType
                Ab(Signed1 depth, ValueType alpha, ValueType beta,
                                   PathType ** bestPath)
{
    Unsigned1       nrMoves;
    MoveType       *moveList,
                    ttMove={0};
    ValueType       value,
                    bestValue,
                    ttValue={0};
    Signed2         i;
    PathType       *tempPath;
    Boolean         betterMoveFound,
                    firstMove;
    MoveType        bestMove,
                    pathMove;
    Signed1         ttDepth={0};
    Unsigned1       flag={0};
    char            s[MaxMoveLength + 1]={0};
    ValueType       maxAlpha;
    Unsigned4       ttNodes={0},
                    startNodes;
    

    maxAlpha = alpha;
    if (nrGamePlies - startPly <= debugDepth) {
        PrintGame(startPly, nrGamePlies - 1);
        printf("%lu (%ld, %ld), (%x, %x)\n", nrTotalNodes, alpha, beta,
               hashValue[nrGamePlies][0], hashValue[nrGamePlies][1]);
    }
    startNodes = nrTotalNodes;
    /* Repetition of position or 50 move rule? */
    if (ItIsADraw()) {
        ++nrLeafNodes;
        if (++nrTotalNodes - nrExtraNodes >= testNrNodes && testNrNodes != -1) {
            stopSearching = True;
        }
        return (Draw);
    }
    GetMoveFromTransTable(ttMove, ttDepth, ttValue, flag, ttNodes);
    if (ttDepth != -1 && nrGamePlies - startPly <= debugDepth) {
        char            sss[10];
        SPrintMove(sss, ttMove);
        printf("From table: %s (val:%d, depth:%d, flag:%d)\n",
               sss, ttValue, ttDepth, flag);
    }
    if (ttDepth != -1 && IsIllegal(ttMove)) {
        SPrintMove(s, ttMove);
        printf("Illegal move %s\n", s);
        ttDepth = -1;
        nrIllegalMoves++;
    }
    /* Use ttValue */
    if (useTtValue && ttDepth >= depth) {
        if (keepMethod == BigAll) {
            nrTotalNodes += ttNodes;
            nrExtraNodes += ttNodes;
        }
        if (flag == Valid) {
            ++nrLeafNodes;
            if (++nrTotalNodes - nrExtraNodes >= testNrNodes && testNrNodes != -1
				) {
                stopSearching = True;
            }
            FreePath(*bestPath);
            AllocatePathMove(*bestPath);
            SPrintMove((*bestPath)->moveString, ttMove);
            (*bestPath)->move = ttMove;
            if (nrGamePlies - startPly <= debugDepth) {
                printf("TT (valid) cut-off\n");
            }
            return (ttValue);
        } else if (flag == LowerBound) {
            if (ttValue > maxAlpha) {
                maxAlpha = ttValue;
            }
        } else {                /* flag == UpperBound */
            if (beta > ttValue) {
                beta = ttValue;
            }
        }
        if (maxAlpha >= beta) {
            ++nrLeafNodes;
            if (++nrTotalNodes - nrExtraNodes >= testNrNodes && testNrNodes != -1) {
                stopSearching = True;
            }
            FreePath(*bestPath);
            AllocatePathMove(*bestPath);
            SPrintMove((*bestPath)->moveString, ttMove);
            (*bestPath)->move = ttMove;
            if (nrGamePlies - startPly <= debugDepth) {
                printf("TT cut-off\n");
            }
            return (ttValue);
        }
    }                           /* if ttDepth >= depth */
    /* Leaf node */
    if (depth == 0) {
        bestValue = Quiescence(maxAlpha, beta, bestPath, ttDepth, ttValue, flag,
                               ttNodes);
        /* Add '.' to show where quiescence starts */
        if (*bestPath != NULL && (*bestPath)->moveString[0] != '.') {
            for (i = MaxMoveLength - 1; i > 0; i--) {
                (*bestPath)->moveString[i] = (*bestPath)->moveString[i - 1];
            }
            (*bestPath)->moveString[0] = '.';
            (*bestPath)->moveString[MaxMoveLength - 1] = '\0';
        }
        return (bestValue);
    }
    firstMove = True;
    nrMoves = 0;
    ++nrInternalNodes;
    if (++nrTotalNodes - nrExtraNodes >= testNrNodes && testNrNodes != -1) {
       
        stopSearching = True;
        return (-Infinity);
    }
    /* Try refutation table move first */
    if (useRefTable && *bestPath != NULL) {
        if ((*bestPath)->moveString[0] == '.') {
            /* Remove '.' for it's no longer quiescence search */
            for (i = 0; i < MaxMoveLength - 2; i++) {
                (*bestPath)->moveString[i] = (*bestPath)->moveString[i + 1];
            }
            (*bestPath)->moveString[MaxMoveLength - 2] = ' ';
            (*bestPath)->moveString[MaxMoveLength - 1] = '\0';
        }
        firstMove = False;
        pathMove = (*bestPath)->move;
        DoMove(&pathMove);
        bestValue = -Ab(depth - 1, -beta, -maxAlpha, &((*bestPath)->next));
        UndoMove();
        bestMove = pathMove;
        if (stopSearching) {
            return (-Infinity);
        }
        if (bestValue >= beta) {
            goto BetaCutOff;
        }
        if (bestValue > maxAlpha) {
            maxAlpha = bestValue;
        }
    } else {
        pathMove.from = 0;      /* no refutation table move */
        FreePath(*bestPath);
        *bestPath = NULL;
    }

    /* Try transposition table move */
    if (useTtMove && ttDepth >= 0 && !EqualMoves(&ttMove, &pathMove)) {
        if (!firstMove) {       /* Refutation move already examined */
            tempPath = NULL;
            DoMove(&ttMove);
            value = -Ab(depth - 1, -maxAlpha - 1, -maxAlpha, &tempPath);
            if (value > bestValue && !stopSearching) {  /* fail high */
                betterMoveFound = True;
                FreePath((*bestPath)->next);
                (*bestPath)->next = tempPath;
                if (value < beta && depth > 0) {        /* re-search */
                    bestValue = -Ab(depth - 1, -Infinity, -value, &((*bestPath)->next));
                } else {
                    bestValue = value;
                }
            } else {
                betterMoveFound = False;
            }
            UndoMove();
            if (betterMoveFound) {
                SPrintMove((*bestPath)->moveString, ttMove);
                (*bestPath)->move = ttMove;
                bestMove = ttMove;
                if (bestValue >= beta) {
                    goto BetaCutOff;
                }
                if (bestValue > maxAlpha) {
                    maxAlpha = bestValue;
                }
            } else {
                FreePath(tempPath);
            }
            if (stopSearching) {
                return (-Infinity);
            }
        } else {                /* No refutation move, so *bestPath equals
                                 * NULL */
            firstMove = False;
            AllocatePathMove(*bestPath);
            DoMove(&ttMove);
            bestValue = -Ab(depth - 1, -beta, -maxAlpha, &((*bestPath)->next));
            UndoMove();
            bestMove = ttMove;
            SPrintMove((*bestPath)->moveString, ttMove);
            (*bestPath)->move = ttMove;
            if (stopSearching) {
                return (-Infinity);
            }
            if (bestValue >= beta) {
                goto BetaCutOff;
            }
            if (bestValue > maxAlpha) {
                maxAlpha = bestValue;
            }
        }
    } else {
        ttMove.from = 0;        /* no transposition table move */
    }

    /* Rest of the moves */
    GenerateMoves(&moveList, &nrMoves);
    if (nrMoves == 0) {
        ++nrLeafNodes;
        --nrInternalNodes;
        if (Attacked(kingSquare[toMove], (SquareType) ! toMove)) {
            return (-Mate + (nrGamePlies - startPly));
        } else {
            return (Draw);      /* Stalemate */
        }
    }
    /* !!! Check evasion: "*/
 
	//if (nrCheck) ++depth;

    /* Construct heap */
    for (i = nrMoves / 2 - 1; i > 0; i--) {
        SiftDown(moveList, (Unsigned1) i, (Unsigned1) (nrMoves - 1));
    }
    for (i = nrMoves - 1; i >= 0; i--) {
        if (i != 0) {           /* Put best move above in list */
            SiftDown(moveList, (Unsigned1) 0, (Unsigned1) i);
        }
        /* Refutation or transposition table move already examined */
        if (EqualMoves(&(moveList[0]), &pathMove) ||
            EqualMoves(&(moveList[0]), &ttMove)) {
            goto Next;
        }
        betterMoveFound = False;
        DoMove(&(moveList[0]));
        if (firstMove) {
            AllocatePathMove(*bestPath);
            bestValue = -Ab(depth - 1, -beta, -maxAlpha, &((*bestPath)->next));
            betterMoveFound = True;
            firstMove = False;
        } else {                /* Not the first move */
            tempPath = NULL;
            value = -Ab(depth - 1, -maxAlpha - 1, -maxAlpha, &tempPath);
            if (value > bestValue && !stopSearching) {  /* fail high */
                FreePath((*bestPath)->next);
                (*bestPath)->next = tempPath;
                betterMoveFound = True;
                if (value < beta && depth > 0) {        /* re-search */
                    bestValue = -Ab(depth - 1, -Infinity, -value, &((*bestPath)->next));
                } else {
                    bestValue = value;
                }
            }
        }
        UndoMove();

        if (stopSearching) {
            FreeMoveList(moveList);
            FreePath(tempPath);
            return (-Infinity);
        }
        if (betterMoveFound) {
            SPrintMove((*bestPath)->moveString, moveList[0]);
            (*bestPath)->move = moveList[0];
            bestMove = moveList[0];
            if (bestValue >= beta) {
                goto BetaCutOff;
            }
            if (bestValue > maxAlpha) {
                maxAlpha = bestValue;
            }
        } else {
            /* Druk variant af als diep genoeg en zo */
            FreePath(tempPath);
        }
Next:
        if (i != 0) {
            moveList[0] = moveList[i];
        }
    }                           /* for moves */

BetaCutOff:
    if (nrMoves) {
        FreeMoveList(moveList);
    }
    if (!IsCaptureMove(bestMove.type)) {
        historyTable[toMove][bestMove.from][bestMove.to] += 1 << depth;
    }
    if (bestValue <= alpha) {
        flag = UpperBound;
    } else if (bestValue >= beta) {
        flag = LowerBound;
    } else {
        flag = Valid;
    }
    PutMoveInTransTable(bestMove, depth, bestValue, flag,
                        nrTotalNodes - startNodes);
    if (nrGamePlies - startPly <= debugDepth) {
        char            sss[10];
        SPrintMove(sss, bestMove);
        printf("To table: %s (val:%d, depth:%d, flag:%d)\n",
               sss, bestValue, depth, flag);
    }
    return (bestValue);
}                               /* Ab */


/*----------------------------------------------------------------------
 | FreePath							940506
 |
 | Frees a move path.
 +----------------------------------------------------------------------*/
void            FreePath(PathType * path)
{
    if (path == NULL) {
        return;
    }
    FreePath(path->next);
    free(path);
    nrAllocPathMoves--;
}                               /* FreePath */


static void     PutMoveInFront(MoveType * moveList, Unsigned1 nrMoves,
                                               MoveType * ttMove)
{
    Signed2         i,
                    j;

    for (i = 0; i < nrMoves; i++) {
        if (EqualMoves(&(moveList[i]), ttMove)) {
            for (j = i; j > 0; j--) {
                moveList[j] = moveList[j - 1];
            }
            moveList[0] = *ttMove;
            break;
        }
    }
}                               /* PutMoveInFront */


static double   PercFilled(void)
{
    return (NrFilled() * 100.0 / (useTwoLevelTable ? 1L << (nrTtBits + 1)
                                  : 1L << nrTtBits));
}                               /* PercFilled */


static          Unsigned4
                NrFilled(void)
{
    Unsigned4       i,
                    nr,
                    tot;

    nr = 0;
    tot = useTwoLevelTable ? 1L << (nrTtBits + 1) : 1L << nrTtBits;
    for (i = 0; i < tot; i++) {
        if (GetFlag(&(transTable[i])) != NoEntry) {
            ++nr;
        }
    }
    return (nr);
}                               /* PercFilled */


static          Unsigned4
                ExpectedCollisions(Unsigned4 nodes)
{
    Unsigned4       tot;

    tot = useTwoLevelTable ? 1L << (nrTtBits + 1) : 1L << nrTtBits;
    return ((Unsigned4) (nodes - tot * (1 - exp((double) -1 * nodes / tot))));
}                               /* ExpectedCollisions */



/*----------------------------------------------------------------------
 | COMMAND							940426
 |
 | Contains all command interpreting functions.
 +----------------------------------------------------------------------*/

static void     PerformHelpCommand(void);
static void     PerformForwardCommand(char *numberString);
static void     PerformBackCommand(char *numberString);
static void     PerformRemovePiece(char *squareString);


/*----------------------------------------------------------------------
 | InterpretCommand						940426
 |
 | Interprets the command string and acts accordingly.
 +----------------------------------------------------------------------*/
Signed2
InterpretCommand()
{

     MoveType        move;
     char         msg[356];
     force_mode = true;
     

	for (;;) {


		if (computer == toMove && !force_mode) {
              
		Search((Signed1) maxdepth, &move, &value);
		
        
        ////////////// resign ////////////////
        if (using_resign) {
		if (value < -Resign_value && resign_count < 3) {			
		resign_count++;
		}else{
        resign_count = 0;
		}	
		if (resign_count == 3) {
			printf("resign\n");
			break;
		}}
		///////////////////////////////////////

       
         ////////// draw offer /////////////
       if (using_draw_offer) {
       if (move_count >= 120 &&  // offer draw from move 120 onwards, 
                                 // only if score is neutral or in deficit 
	   value <= 0 && !draw_offer) {
       printf("\noffer draw\n");
       draw_offer = true; 
       }else{
       draw_offer = false;
       } 
       if (draw_offer && move_count == 150 || move_count == 160
	   || move_count == 170 || move_count == 180 || move_count == 190) {
       draw_offer = false;
       }}
       /////////////////////////////////

     
		if (move.from) {
            SPrintMove(wb_command, move);
            printf("move %s\n", wb_command);
            if (icc) printf("tellics whisper kibitz %s\n", wb_command);
			move_count++;
		//	printf("[alibaba] move no. %d\n",move_count);
		    
        if (move_count == 40) move_count = 0;
         
            DoMove(&move);
        }
		
		if (print_board) PrintBoard();  
        continue;
	    }	 				

	if (!fgets(line, 256, stdin)) {
        return 1;
		}

		if (line[0] == '\n') {
		continue;
		}
                      

  if (!xboard_mode)  printf("\n> ");
  
       sscanf(line, "%s", wb_command); 
  		

if (!strcmp(wb_command, "quit") || !strcmp(wb_command, "exit")) {         
	 printf("\nalibaba terminating!\n");  
  	// exit(0);
    ExitProcess(0); /* use this windows api call on final compile 
                      to make sure process is terminated fully on exit */
}

if (!strcmp(wb_command, "go")) { 
	computer = toMove;
	force_mode = false;
}                

if (!strcmp(wb_command, "sd")) { 
    int sd;
    sscanf(line,"sd %d",&sd);
    maxdepth = (Signed1) sd;
    maxtime = 1 << 25;
    printf("\ndepth set to %d\n",sd);
    continue;	
}           
       
if (!strcmp(wb_command, "protover")) { 
    printf("feature colors=1\n");
    printf("feature myname=\"AliBaba %s by D.Breuker\"\n",VERSION);
    printf("feature time=1\n");
    printf("feature pause=0\n");
    printf("feature sigint=0\n");
    printf("feature sigterm=0\n");
    printf("feature reuse=0\n");
	printf("feature draw=1\n");
	printf("feature random=0\n");
    printf("feature pause=0\n");
    printf("feature variants=\"normal\"\n");
	printf("feature setboard=0\n");
	printf("feature ping=1\n");
	printf("feature ics=1\n");
	printf("feature memory=1\n");
    printf("feature done=1\n");
    continue;
}                
  

if (!strcmp(wb_command, "memory")) {
      
	 if (memory_on) {
     sscanf(line, "memory %d", &memory);
	 
   /* <hashsize> is an integer, denoting the number of bits of the
      hash index. The size of the hash table is 2^<number of bits> positions.
     . EXAMPLE: memory 16
      uses a transposition table with 65536 (2^16) positions. */

	 /* set hash size */
	 
	 if (memory == 3)   hashsize = 16;           /* 3mb   */
	 else
	 if (memory == 6)   hashsize = 17;           /* 6mb   */
	 else
	 if (memory == 17)  hashsize = 18;           /* 12mb  */ 
	 else
     if (memory == 22)  hashsize = 20;           /* 22mb */
	 else
	 if (memory == 32)  hashsize = 19;           /* 32mb  */ 
	 else
	 if (memory == 84)  hashsize = 22;           /* 82mb */
	 else
	 if (memory == 164) hashsize = 23;           /* 164 mb */
	 else
     
	 /* if hash size chosen is not one of above, set to a
	    suitable hash size that is in range. */
	 
	 if (memory < 5)    hashsize = 16;           /* 3mb  */
	 else
     if (memory < 10)   hashsize = 17;           /* 6mb  */
	 else
     if (memory < 17)   hashsize = 18;           /* 12mb  */ 
     else
     if (memory < 26)   hashsize = 20;           /* 22mb */          
     else
     if (memory < 50)   hashsize = 19;           /* 32mb */                    
	 else
     if (memory < 100)  hashsize = 22;           /* 82mb */
     else
     if (memory < 200)  hashsize = 23;           /* 164mb */
     	 
	 nrTtBits = hashsize;    
     }
     continue;
}


if (!strcmp(wb_command,"variant")) {
     char variant[256];
     sscanf(line, "variant %s",variant);
     if (strcmp(variant,"normal")) 
	 printf("unknown variant\n");
     continue;
     } 	
     
     
     
if (!strcmp(wb_command, "ics")) { // are we on an internet chess server?
			if(line[4] == '-') {
				icc = false;
			} else {
				icc = true;
			}
			continue;
		}
		    
    
if (!strcmp(wb_command, "told")) {
			// told via "tell" msg or left a msg via "message"
			strcpy(msg, (line+5));
			printf("tellics kibitz %s\n",msg);
			printf("tellics draw\n");			
		 continue;
        }
		
	
if (!strcmp(wb_command, "whispered")) {
			// whispered to via "whisper"
        continue;
}
		
 if (!strcmp(wb_command, "heardkibitz")) {
			// picked up a kibitz
        continue;
}
		
if (!strcmp(wb_command, "heardshout")) {
        continue;
}
		
if (!strcmp(wb_command, "heardsshout")) {
        continue;
}    

            
            
if (!strcmp(wb_command,"rating")) {
		int my_rating,opp_rating;
		scanf("%d",&my_rating);
		scanf("%d",&opp_rating);
		continue;
	}            
           
           
               

if (!strcmp(wb_command, "new")) { 
	ReadINIFile(INI_FILENAME);
    first_move = true;	
	Init();
    TestArguments();
    force_mode = false;
    maxdepth = 32;
    computer = Black;
    if (icc) printf("tellics say Thanks for playing me!\n");
	continue;
}                
	
if (!strcmp(wb_command, "white")) { 
	 if (using_bookthinker) {
     computer = White; 
     }else{
     computer = Black;
     }       
     continue;		
}    
	
if (!strcmp(wb_command, "black")) { 
	if (using_bookthinker) {
    computer = Black;
    }else{
    computer = White;
    }
    continue;	
}   

if (!strcmp(wb_command, "force")) { 
    computer  = Empty;
	force_mode = true;
	continue;		
}    

if (!strcmp(wb_command, "draw")) {
    if (draw_offer || value <= -300) {    // if alibaba already has a 'draw offer' pending
		   printf("\noffer draw\n"); // or best score is low, accept the draw 
		   continue;
	}else{
  
           printf("\ndraw offer declined!\n");
           printf("AliBaba is still optimistic about it's chances\n");
           printf ("to win!\n"); 		
}}


if (!strcmp(wb_command, "result")) {
     char result[256];
     sscanf(line,"result %s",result);
     computer = Empty;
     continue;
}

if (!strcmp(wb_command, "st")) {
	 st_time = true;
     sscanf(line, "st %d", &maxtime);
     maxtime *= 1000;
     maxdepth = 32;
	 continue;
}


if (!strcmp(wb_command, "undo")) {
	 char undo[256];
     sscanf(line, "undo %s", undo);
     PerformBackCommand(undo);
	 continue;
}


if (!strcmp(wb_command, "ping")) {
	 int n; 
     sscanf(line,"%*s %d",&n);
     printf("pong %d\n",n); 
	 continue;
}


if (!strcmp(wb_command, "time")) {       
     sscanf(line, "time %d", &maxtime);   
     if (minutes == 1 || minutes == 2) { /* 1 or 2 min game - special case */
     maxtime *= 10;
     maxtime /= 80;
     }else{
     if (maxtime < 2000) { // critical - move a bit faster 	
     maxtime *= 8;
     maxtime /= (max_moves+move_count);
     }else{
     maxtime *= 12;
     maxtime /= (max_moves+move_count);
     }}
     maxdepth = 32;     
     continue;         
}


if (!strcmp(wb_command, "level")) { 
    sscanf(line, "level %d %d", &max_moves,&minutes);
    if (!max_moves) max_moves = 40;
    continue;
}  


if (!strcmp(wb_command, "easy")) { 
    continue;
}  

if (!strcmp(wb_command, "hard")) { 
    continue;
}       

if (!strcmp(wb_command, "accepted")) { 
    continue;
}       

if (!strcmp(wb_command, "?")) { 
    Stop_Search = true;
	continue;
}    

if (!strcmp(wb_command, "computer")) { 
    continue;
}       
 
if (!strcmp(wb_command, "otim")) { 
    scanf("%d",&time_left_opponent);
	time_left_opponent *= 10;
    time_left_opponent /= 60;
	continue;
}       

if (!strcmp(wb_command, "post")) {
	post = true;
	continue;
}

if (!strcmp(wb_command, "nopost")) {
	post = false;		
	continue;
}


if (!strcmp(wb_command, "rejected")) {
	continue;
}


if (!strcmp(wb_command, "accepted")) {
	continue;
}

if (!strcmp(wb_command, "random")) {
	continue;
}

if (!strcmp(wb_command, "xboard")) { 
    xboard_mode=true;
    printf("feature done=0\n");  
    continue;
}                


if(strcspn(line, "ijklmopstuvwxyz90") < strlen(line)){
	if (move_count && strcmp(wb_command,"go") && 
                      strcmp(wb_command,"rejected")) {
     printf("Error (unknown command): %s\n", wb_command);
     }
	continue;
}



/* At this point, the command better be a move  */

   PerformMoveCommand(wb_command);	
   continue;
        
}

return 1;
}


	
	

/*----------------------------------------------------------------------
 | MAIN							940420
 |
 | Contains the main program.
 +----------------------------------------------------------------------*/



void Start(void)
{
	    printf("\nAliBaba chess engine v%s\n",VERSION);
		printf("------------------------------\n");
        printf("\n%s, (c) D.M. Breuker\n", version);
		printf("Winboard support by Jim Ablett [%s]\n",BUILDDATE);
   
  
}


/*----------------------------------------------------------------------
 | Main program							940420
 +----------------------------------------------------------------------*/

int             CDECL
                main(int argc, char *argv[])
{
    
	int i;
    computer = Black;
    
    setbuf(stdout, NULL);
    setbuf(stdin, NULL);
    setvbuf(stdout, NULL, _IONBF, 0);
    setvbuf(stdin, NULL, _IONBF, 0);   
    

	signal(SIGINT, catch_sigint);
	

         /* set hash with command-line option */
	
    	 for (i = 1; i < argc; i++) {
             
         if (strcmp(argv[i], "-hash-3") == 0) {
            hashsize = 16;   /* 3mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;
        }else
         if (strcmp(argv[i], "-hash-6") == 0) {
            hashsize = 17;   /* 6mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;
         }else   
         if (strcmp(argv[i], "-hash-12") == 0) {
            hashsize = 18;  /* 12mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;   
          }else   
         if (strcmp(argv[i], "-hash-22") == 0) {
            hashsize = 20;  /* 22mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;     
           }else   
         if (strcmp(argv[i], "-hash-32") == 0) {
            hashsize = 19;  /* 32mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;    
          }else   
         if (strcmp(argv[i], "-hash-82") == 0) {
            hashsize = 22;  /* 82mb */
            nrTtBits = hashsize;   
            memory_on = false;
            i++;     
           }else   
         if (strcmp(argv[i], "-hash-164") == 0) {
            hashsize = 23;  /* 164mb */
            nrTtBits = hashsize;   
            memory_on = false; 
            i++;   
           }
           
                 
           
           
        
         } 
           
           
    
    Start();
    
    interActive = True;
 
    if (interActive) {
        for (Ever) {
    
	printf("\n--------\n");
	printf("\nThis version of AliBaba is Winboard only!.\n");
	printf("\nIt must be loaded into a Winboard compatible\n");
	printf("\nchess gui interface.\n\n");
	printf("Type 'quit' or 'exit' to terminate\n\n");
			
	printf("\n> ");
        
           
            InterpretCommand();
                break;
            }
        
    }
    PrintAllocVariables();

    

}          /* main */



/*----------------------------------------------------------------------
 | PerformMoveCommand						940426
 |
 | Performs the "move" command.
 +----------------------------------------------------------------------*/
void            PerformMoveCommand(char *moveString)
{
    MoveType       *moveList;
    Unsigned1       nrMoves;
    Signed2         i;
	Signed2          n;
    char            s[MaxCommandLength],
                   *ptr;


    if (moveString[0] == '\0') {
    if (!first_move) {
		printf("ERROR: move required\n");
		}else{
		first_move = false;
		}
        return;
	    }

	
	if (!force_mode) {

	for (n=0; n < MaxCommandLength; n++) {
		if (moveString[n] == '-') goto start;
	}}	

	if (computer == toMove) {
         if (!strcmp(wb_command, "e8g8") || !strcmp(wb_command, "e1g1")) {
                    moveString[0] = '0';
                    moveString[1] = '-';
					moveString[2] = '0';
					moveString[3] = '\0';
	                goto start;
		 }
	
    if (!strcmp(wb_command, "e8c8") || !strcmp(wb_command, "e1c1")) {
                    moveString[0] = '0';
                    moveString[1] = '-';
					moveString[2] = '0';
					moveString[3] = '-';
					moveString[4] = '0';
					moveString[5] = '\0';
                    goto start;
}}
					
					moveString[5] = '\0';
                    moveString[4] = moveString[3];
					moveString[3] = moveString[2];
					moveString[2] = '-';
				 
	
start:

    GenerateMoves(&moveList, &nrMoves);
    for (i = 0; i < nrMoves; i++) {
        SPrintMove(s, moveList[i]);
        for (ptr = s; *ptr == ' '; ptr++);
        if (strncmp(ptr, moveString, strlen(moveString)) == 0) {
            DoMove(&(moveList[i]));
            move_count++;
            break;
        }
    }
    if (nrMoves) {
        FreeMoveList(moveList);
    }
    if (i == nrMoves) {
		printf("ERROR: illegal move '%s'\n", moveString);
   }
}                               /* PerformMoveCommand */


/*----------------------------------------------------------------------
 | PerformForwardCommand					940429
 |
 | Executes several moves.
 +----------------------------------------------------------------------*/
static void     PerformForwardCommand(char *numberString)
{
    Signed2         i,
                    nrForward;
    int             dummy;

    if (nrGamePlies >= maxGamePlies) {
        printf("ERROR: no more moves\n");
    } else {
        if (numberString[0] == '\0') {
            nrForward = 1;
        } else {
            sscanf(numberString, "%d", &dummy);
            nrForward = (Signed2) dummy;
        }
        if (nrForward > maxGamePlies - nrGamePlies) {
            nrForward = maxGamePlies - nrGamePlies;
        }
        for (i = 0; i < nrForward; i++) {
            if ((toMove == White && nrGamePlies % 2 == 0) ||
                (toMove == Black && nrGamePlies % 2 == 1)) {
                printf("Doing move %d.", nrGamePlies / 2 + 1);
                if (nrGamePlies % 2 == 1) {
                    printf("..");
                }
            } else {
                printf("Doing move %d.", (nrGamePlies + 1) / 2 + 1);
                if ((nrGamePlies + 1) % 2 == 1) {
                    printf("..");
                }
            }
            printf("%s\n", gameString[nrGamePlies]);
            DoMove(&(game[nrGamePlies]));
        }
    }
}                               /* PerformForwardCommand */


/*----------------------------------------------------------------------
 | PerformBackCommand						940429
 |
 | Takes several moves back.
 +----------------------------------------------------------------------*/
static void     PerformBackCommand(char *numberString)
{
    Signed2         nrBack,
                    i;
    int             dummy;

    if (nrGamePlies == 0) {
        printf("ERROR: no moves to take back\n");
    } else {
        if (numberString[0] == '\0') {
            nrBack = 1;
        } else {
            sscanf(numberString, "%d", &dummy);
            nrBack = (Signed2) dummy;
        }
        if (nrBack > nrGamePlies) {
            nrBack = nrGamePlies;
        }
        for (i = 0; i < nrBack; i++) {
            if ((toMove == White && nrGamePlies % 2 == 0) ||
                (toMove == Black && nrGamePlies % 2 == 1)) {
                printf("Undoing move %d.", (nrGamePlies - 1) / 2 + 1);
                if ((nrGamePlies - 1) % 2 == 1) {
                    printf("..");
                }
            } else {
                printf("Undoing move %d.", nrGamePlies / 2 + 1);
                if (nrGamePlies % 2 == 1) {
                    printf("..");
                }
            }
            printf("%s\n", gameString[nrGamePlies - 1]);
            UndoMove();
        }
    }
}                               /* PerformBackCommand */


/*----------------------------------------------------------------------
 | PerformPlacePiece						940429
 |
 | Places a piece on the board.
 +----------------------------------------------------------------------*/
void            PerformPlacePiece(char *pieceString)
{
    SquareType      piece;
    BoardIndexType  square;
    char           *ptr;

    if (tolower(pieceString[0]) == 'w') {
        piece = White;
    } else if (tolower(pieceString[0]) == 'b') {
        piece = Black;
    } else {
        printf("ERROR: Unknown color in piece '%s'\n", pieceString);
        return;
    }
    if (strlen(pieceString) == 3) {
        ptr = &(pieceString[1]);
        piece |= Pawn;
    } else {
        ptr = &(pieceString[2]);
        switch (tolower(pieceString[1])) {
        case 'k':
            piece |= King;
            break;
        case 'q':
            piece |= Queen;
            break;
        case 'r':
            piece |= Rook;
            break;
        case 'b':
            piece |= Bishop;
            break;
        case 'n':
            piece |= Knight;
            break;
        case 'p':
            piece |= Pawn;
            break;
        default:
            printf("ERROR: unknown piece in piece '%s'\n", pieceString);
            return;
        }                       /* switch */
    }
    square = Square(tolower(ptr[0]) - 'a' + A, ptr[1] - '0');
    if (Rank(square) < 1 || Rank(square) > 8 ||
        File(square) < A || File(square) > H ||
        !IsEmpty(board[square])) {
        printf("ERROR: wrong square in piece '%s'\n", pieceString);
        return;
    }
    PlacePiece(piece, square);
}                               /* PerformPlacePiece */


/*----------------------------------------------------------------------
 | PerformRemovePiece						940429
 |
 | Removes a piece from a square.
 +----------------------------------------------------------------------*/
static void     PerformRemovePiece(char *squareString)
{
    BoardIndexType  square;
    SquareType      color;
    HashType       *table;

    square = Square(tolower(squareString[0]) - 'a' + A,
                    squareString[1] - '0');
    if (IsEmpty(board[square]) || IsEdge(board[square])) {
        printf("ERROR: wrong square '%s'\n", squareString);
        return;
    }
    color = Color(board[square]);
    material[color] -= pieceValue[board[square]];
    pieces[color][pieceIndex[square]] =
        pieces[color][--nrPieces[color]];
    pieceIndex[pieces[color][pieceIndex[square]].square] =
        pieceIndex[square];
    GetHashTable(table, color, board[square]);
    HashXorIs(hashValue[nrGamePlies], table[square]);
    board[square] = Empty;
}                               /* PerformRemovePiece */


/*----------------------------------------------------------------------
 | PerformHelpCommand						940426
 |
 | Performs the "help" command.
 +----------------------------------------------------------------------*/
static void     PerformHelpCommand(void)
{
    printf("Long                         Short  Description\n");
    printf("-------------------------------------------------------------------------\n");
    printf("help                         h      Print this information\n");
    printf("printboard                   pb     Print the board\n");
    printf("new                          n      New game\n");
    printf("list                         lm     Print the move list\n");
    printf("move <move>                  m      Make a move; e.g., m Nb1xd2\n");
    printf("compute [depth]              c      Compute a move; e.g., c 6\n");
    printf("back [number]                b      Take last number of moves back\n");
    printf("forward [number]             f      Undo last number of takebacks\n");
    printf("printgame                    pg     Print game moves\n");
    printf("save <file>                  s      Save game; e.g., s test\n");
    printf("load <file>                  l      Load game\n");
    printf("clear                        cb     Clear board\n");
    printf("place <color><piece><square> pp     Put piece on square; e.g., pp WNe4\n");
    printf("remove <square>              rp     Remove piece from square; e.g., rp e4\n");
    printf("quit                         q      Quit the program\n");
}                               /* PerformHelpCommand */



/*----------------------------------------------------------------------
 | DIKSIO							940429
 |
 | Contains all disk I/O functions.
 +----------------------------------------------------------------------*/

static Boolean  OpenFileForWriting(FILE ** fp, char *name);
static Boolean  OpenFileForReading(FILE ** fp, char *name);
static Signed2  GetLine(FILE * fp, char *s);

/*----------------------------------------------------------------------
 | SaveGame							940429
 |
 | Saves the starting position and the resulting game moves.
 +----------------------------------------------------------------------*/
void            SaveGame(char *filename)
{
    Signed2         nr,
                    i;
    char            name[MaxFileNameLength],
                    s[MaxCommandLength];
    FILE           *fp;

    if (filename[0] == '\0') {
        printf("ERROR: filename required\n");
        printf("Game not saved\n");
    } else {
        strcpy(name, GameDirectory);
        strcat(name, filename);
        if (FileExists(name)) {
            printf("File already exists, overwrite (Y/N) ? ");
            do {
                gets(s);
                if (tolower(s[0]) == 'n') {
                    printf("Game not saved\n");
                    return;
                }
            }
            while (tolower(s[0]) != 'y');
        }
        if (OpenFileForWriting(&fp, name)) {
            printf("Game not saved\n");
            return;
        }
        /* take back all moves */
        nr = nrGamePlies;
        for (i = 0; i < nr; i++) {
            UndoMove();
        }
        /* save starting position and game */
        for (i = 0; i < nrPieces[White]; i++) {
            SPrintSquare(s, pieces[White][i].square);
            fprintf(fp, "%c%s ",
                    IsPawn(pieces[White][i].type) ? ' ' :
                    pieceSymbol[pieces[White][i].type], s);
        }
        fprintf(fp, "\n");
        for (i = 0; i < nrPieces[Black]; i++) {
            SPrintSquare(s, pieces[Black][i].square);
            fprintf(fp, "%c%s ",
                    IsPawn(pieces[Black][i].type) ? ' ' :
                    pieceSymbol[pieces[Black][i].type | White], s);
        }
        fprintf(fp, "\n");
        if (epSquare[0] == NoEp) {
            s[0] = '\0';
        } else {
            SPrintSquare(s, epSquare[0]);
        }
        fprintf(fp, "%s %s ", moveColorString[toMove], s);
        if (castling[nrGamePlies] & WhiteShort) {
            fprintf(fp, "WS ");
        }
        if (castling[nrGamePlies] & WhiteLong) {
            fprintf(fp, "WL ");
        }
        if (castling[nrGamePlies] & BlackShort) {
            fprintf(fp, "BS ");
        }
        if (castling[nrGamePlies] & BlackLong) {
            fprintf(fp, "BL ");
        }
        fprintf(fp, "\n");
        /* execute all moves */
        for (i = 0; i < nr; i++) {
            if (i % 2 == 0) {
                fprintf(fp, "%3d.", i / 2 + 1);
            }
            fprintf(fp, "%s ", gameString[i]);
            if (i % 8 == 7) {
                fprintf(fp, "\n");
            }
            DoMove(&(game[i]));
        }
        fprintf(fp, "\n");
        fclose(fp);
        printf("Game saved\n");
    }                           /* else */
}                               /* SaveGame */


/*----------------------------------------------------------------------
 | LoadGame							940429
 |
 | Loads a position and the resulting game moves.
 +----------------------------------------------------------------------*/
void            LoadGame(char *filename)
{
    Signed2         i;
    char            name[MaxFileNameLength],
                    s[MaxCommandLength];
    char           *ptr,
                    string[MaxCommandLength];
    char            temp[MaxCommandLength],
                   *p;
    FILE           *fp;
    Boolean         stop,
                    initialPos;

    if (filename[0] == '\0') {
        printf("ERROR: filename required\n");
        goto ErrorLabel;
    } else {
        strcpy(name, GameDirectory);
        strcat(name, filename);
        if (OpenFileForReading(&fp, name)) {
            goto ErrorLabel;
        }
        EmptyBoard();
        /* load starting position and game */
        /* white pieces */
        if (GetLine(fp, s)) {
            printf("ERROR: file too small\n");
            goto ErrorLabel;
        }
        sscanf(s, "%s", string);
        if (strlen(string) > 3 ||
            strchr(string, '.') != NULL) {      /* Assume it is a move */
            initialPos = True;
            StartingPosition();
        } else {
            initialPos = False;
            ptr = s;
            SkipSpaces(ptr);
            while (ptr[0] != '\0') {
                string[0] = 'w';
                sscanf(ptr, "%s", &(string[1]));
                PerformPlacePiece(string);
                ptr += strlen(string) - 1;
                SkipSpaces(ptr);
            }
            /* black pieces */
            if (GetLine(fp, s)) {
                printf("ERROR: file too small\n");
                goto ErrorLabel;
            }
            ptr = s;
            SkipSpaces(ptr);
            while (ptr[0] != '\0') {
                string[0] = 'b';
                sscanf(ptr, "%s", &(string[1]));
                PerformPlacePiece(string);
                ptr += strlen(string) - 1;
                SkipSpaces(ptr);
            }
            if (GetLine(fp, s)) {
                printf("ERROR: file too small\n");
                goto ErrorLabel;
            }
            ptr = s;
            /* color to move */
            sscanf(ptr, "%s", string);
            if (strcmp(string, moveColorString[White]) == 0) {
                toMove = White;
            } else if (strcmp(string, moveColorString[Black]) == 0) {
                toMove = Black;
            } else {
                printf("ERROR: unknown color in '%s'\n", string);
                goto ErrorLabel;
            }
            ptr += strlen(string);
            SkipSpaces(ptr);
            string[0] = '\0';
            /* ep square */
            sscanf(ptr, "%s", string);
            if (string[0] == '\0' ||
                tolower(string[1]) == 's' || tolower(string[1]) == 'l') {
                epSquare[0] = NoEp;
            } else {
                epSquare[0] = Square(tolower(string[0]) - 'a' + A, string[1] - '0');
                ptr += strlen(string);
                SkipSpaces(ptr);
            }
            /* castlings */
            while (ptr[0] != '\0') {
                sscanf(ptr, "%s", string);
                if (tolower(string[0]) == 'w') {
                    if (tolower(string[1]) == 's') {
                        castling[0] |= WhiteShort;
                    } else if (tolower(string[1]) == 'l') {
                        castling[0] |= WhiteLong;
                    } else {
                        printf("ERROR: unknown castling in '%s'\n", string);
                        goto ErrorLabel;
                    }
                } else if (tolower(string[0]) == 'b') {
                    if (tolower(string[1]) == 's') {
                        castling[0] |= BlackShort;
                    } else if (tolower(string[1]) == 'l') {
                        castling[0] |= BlackLong;
                    } else {
                        printf("ERROR: unknown castling in '%s'\n", string);
                        goto ErrorLabel;
                    }
                } else {
                    printf("ERROR: unknown color in '%s'\n", string);
                    goto ErrorLabel;
                }
                ptr += strlen(string);
                SkipSpaces(ptr);
            }                   /* while */
        }                       /* else: read position */
        /* read and execute all moves */
        if (!initialPos) {
            s[0] = '\0';
        }
        ptr = s;
        SkipSpaces(ptr);
        stop = False;
        for (i = 0;; i++) {
            while (*ptr == '\0') {
                if (GetLine(fp, s)) {
                    stop = True;
                    break;
                }
                ptr = s;
                SkipSpaces(ptr);
            }
            if (stop) {
                break;
            }
            sscanf(ptr, "%s", temp);
            p = strchr(temp, '.');
            if (p != NULL) {
                if (p[1] == '\0') {
                    --i;
                } else {
                    strcpy(gameString[i], &(p[1]));
                    PerformMoveCommand(gameString[i]);
                }
            } else {
                strcpy(gameString[i], temp);
                PerformMoveCommand(gameString[i]);
            }
            ptr += strlen(temp);
            SkipSpaces(ptr);
        }
        fclose(fp);
        printf("Game loaded\n");
    }                           /* else */
    return;
ErrorLabel:
    printf("Game not loaded\n");
    EmptyBoard();
    StartingPosition();
    return;
}                               /* LoadGame */


/*----------------------------------------------------------------------
 | OpenFileForWriting						940429
 |
 | Opens file with name 'name' and creates handle '*fp'.
 +----------------------------------------------------------------------*/
static          Boolean
                OpenFileForWriting(FILE ** fp, char *name)
{
    if ((*fp = fopen(name, "w")) == NULL) {
        printf("ERROR: cannot open file '%s'\n", name);
        return (True);
    }
    return (False);
}                               /* OpenFileForWriting */


/*----------------------------------------------------------------------
 | OpenFileForReading						940429
 |
 | Opens file with name 'name' and creates handle '*fp'.
 +----------------------------------------------------------------------*/
static          Boolean
                OpenFileForReading(FILE ** fp, char *name)
{
    if ((*fp = fopen(name, "r")) == NULL) {
        printf("ERROR: cannot open file '%s'\n", name);
        return (True);
    }
    return (False);
}                               /* OpenFileForReading */


static          Signed2
                GetLine(FILE * fp, char *s)
{
    char           *ptr;

    for (;;) {
        if (fgets(s, MaxCommandLength, fp) == NULL) {
            return (1);
        }
        ptr = s;
        SkipSpaces(ptr);
        if (*ptr != '%') {      /* No comment line? */
            break;
        }
    }
    s[strlen(s) - 1] = '\0';
    return (0);
}                               /* GetLine */


void            SaveLatexPos(char *ptr)
{
    char            s[4],
                    filename[20];
    FILE           *fp;
    Signed2         i;

    if (*ptr == '\0') {
        strcpy(filename, "pos.tex");
    } else {
        strcpy(filename, ptr);
    }
    if (!OpenFileForWriting(&fp, filename)) {
        fprintf(fp, "\\maakstelling\n");
        fprintf(fp, "  {");
        for (i = 0; i < nrPieces[White]; i++) {
            if (!IsPawn(pieces[White][i].type)) {
                fprintf(fp, "%c",
                        toupper(pieceSymbol[pieces[White][i].type]));
            }
            SPrintSquare(s, pieces[White][i].square);
            fprintf(fp, "%s", s);
            if (i < nrPieces[White] - 1) {
                fprintf(fp, ", ");
            }
        }
        fprintf(fp, "}\n");

        fprintf(fp, "  {");
        for (i = 0; i < nrPieces[Black]; i++) {
            if (!IsPawn(pieces[Black][i].type)) {
                fprintf(fp, "%c",
                        toupper(pieceSymbol[pieces[Black][i].type]));
            }
            SPrintSquare(s, pieces[Black][i].square);
            fprintf(fp, "%s", s);
            if (i < nrPieces[Black] - 1) {
                fprintf(fp, ", ");
            }
        }
        fprintf(fp, "}\n");

        fprintf(fp, "  {Move %d (%s)}\n", (nrGamePlies) / 2 + 1,
                moveColorString[toMove]);
        fclose(fp);

        printf("Position saved in '%s'\n", filename);
    }
}                               /* SaveLatexPos */








/*----------------------------------------------------------------------
 | EVALUATE 							940502
 |
 | Contains position evaluation functions.
 +----------------------------------------------------------------------*/




static Boolean  NoMoves(void);
static Boolean  PawnCanMove(BoardIndexType square);
static Boolean  KnightCanMove(BoardIndexType square);
static Boolean  BishopCanMove(BoardIndexType square);
static Boolean  RookCanMove(BoardIndexType square);
static Boolean  KingCanMove(BoardIndexType square);
static Boolean  CaptureMovesAvailable(CheckPieceType * piece);
static Boolean  PawnCaptureMovesAvailable(CheckPieceType * piece);
static Boolean  KnightCaptureMovesAvailable(CheckPieceType * piece);
static Boolean  BishopCaptureMovesAvailable(CheckPieceType * piece);
static Boolean  RookCaptureMovesAvailable(CheckPieceType * piece);
static Boolean  InterposingMovesAvailable(CheckPieceType * piece);
static Boolean  ToMovesAvailable(BoardIndexType to);
static Boolean  PawnToMovesAvailable(BoardIndexType to);
static Boolean  KnightToMovesAvailable(BoardIndexType to);
static Boolean  BishopToMovesAvailable(BoardIndexType to);
static Boolean  RookToMovesAvailable(BoardIndexType to);


/*----------------------------------------------------------------------
 | Evaluate							940502
 |
 | Evaluates a position. 'toMove' is the person who is to move.
 +----------------------------------------------------------------------*/
ValueType
Evaluate(Signed1 ttDepth, ValueType ttValue, Unsigned1 flag,
         Unsigned4 ttNodes)
{
    ValueType       value,
                    readValue;
    MoveType        readMove;
    Unsigned1       readFlag;
    Signed1         readDepth;
    Unsigned4       readNodes;

   

    if (ttDepth == -2) {
        GetMoveFromTransTable(readMove, readDepth, readValue, readFlag,
                              readNodes);
    } else {
        readDepth = ttDepth;
        readValue = ttValue;
        readFlag = flag;
        readNodes = ttNodes;
    }
    if (NoMoves()) {
        return (nrCheck ? -Mate + (nrGamePlies - startPly) : Draw);
    }
    if (nrCheck) {
        return (-Infinity);
    }
    value = material[toMove] + positionalValue[toMove] -
        material[!toMove] - positionalValue[!toMove];

	
    if (useTtValue && readDepth != -1) {
        if (keepMethod == BigAll) {
            nrExtraNodes += readNodes;
            nrTotalNodes += readNodes;
        }
        if ((readFlag == UpperBound && value > readValue) ||
            (readFlag == LowerBound && value < readValue) ||
            readFlag == Valid) {
            value = readValue;
        }
    }
    return (value);
}                               /* Evaluate */


/*----------------------------------------------------------------------
 | NoMoves.							940509
 |
 | Returns 'True' if no moves are available for color 'toMove'. Otherwise
 | 'False' is returned;
 +----------------------------------------------------------------------*/


static          Boolean
                NoMoves(void)
{
    PieceType      *pieceTable;
    Unsigned1       nr;
    SquareType      piece;
    Signed2         i;

    pieceTable = pieces[toMove];
    nr = nrPieces[toMove];

    SearchForPinsAndCheck();
    switch (nrCheck) {
    case 0:
        for (i = 0; i < nr; i++) {
            piece = pieceTable[i].type;
            if (IsPawn(piece) && PawnCanMove(pieceTable[i].square)) {
                return (False);
            } else if (IsKnight(piece) && !pinned[pieceTable[i].square] &&
                       KnightCanMove(pieceTable[i].square)) {
                return (False);
            } else if (IsKing(piece) && KingCanMove(pieceTable[i].square)) {
                return (False);
            } else {
                if (MovesDiagonal(piece) &&
                    BishopCanMove(pieceTable[i].square)) {
                    return (False);
                }
                if (MovesStraight(piece) &&
                    RookCanMove(pieceTable[i].square)) {
                    return (False);
                }
            }
        }                       /* for i */
        break;
    case 1:
        /* Capture check-giving piece, NOT with king */
        if (CaptureMovesAvailable(&(checkingPiece[0]))) {
            return (False);
        }
        /* Interpose piece */
        if (checkingPiece[0].dir &&
            kingSquare[toMove] + checkingPiece[0].dir !=
            checkingPiece[0].square &&
            InterposingMovesAvailable(&(checkingPiece[0]))) {
            return (False);
        }
    case 2:
        /* Move king away, including trying to capture (one of) the
         * check-giving piece(s) */
        if (KingCanMove(kingSquare[toMove])) {
            return (False);
        }
        break;
    default:
        printf("ERROR: %d times in check\n", nrCheck);
        exit(0);
    }                           /* switch */
    return (True);
}                               /* NoMoves */







/*----------------------------------------------------------------------
 | GeneratePawnMoves						940420
 |
 | Generates all legal pawn moves.
 +----------------------------------------------------------------------*/
static          Boolean
                PawnCanMove(BoardIndexType from)
{
    BoardIndexType  to;
    SquareType      piece;
    Unsigned1       dir;
    PieceType       attackingPiece;

    /* non-capture moves */
    if (!pinned[from] || pinned[from] == Up || pinned[from] == Down) {
        to = pawnMoveTable[toMove][from][0];
        if (IsEmpty(board[to])) {
            return (True);
        }
    }                           /* if not pinned */
    /* capture moves */
    for (dir = 0; dir < 2; dir++) {
        if (!pinned[from] || pinned[from] == pawnCaptureDir[toMove][dir] ||
            pinned[from] == -pawnCaptureDir[toMove][dir]) {
            to = pawnCaptureTable[toMove][from][dir];
            if (to == epSquare[nrGamePlies]) {
                /* remove pawns temporarily */
                board[from] = Empty;
                board[to + (toMove == White ? Down : Up)] = Empty;
                if (FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                       rookTable[kingSquare[toMove]][2], &attackingPiece)) {
                    if (attackingPiece.type != (Rook | !toMove) &&
                        attackingPiece.type != (Queen | !toMove)) {
                        if (FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                        rookTable[kingSquare[toMove]][3], &attackingPiece)) {
                            if (attackingPiece.type != (Rook | !toMove) &&
                                attackingPiece.type != (Queen | !toMove)) {
                                /* Put pawns back */
                                board[from] = Pawn | toMove;
                                board[to + (toMove == White ? Down : Up)] = Pawn | !toMove;
                                return (True);
                            }
                        }
                    }
                }
                /* Put pawns back */
                board[from] = Pawn | toMove;
                board[to + (toMove == White ? Down : Up)] = Pawn | !toMove;
            } else {
                piece = board[to];
                if (piece && !IsEdge(piece) && !IsColor(piece, toMove)) {
                    return (True);
                }               /* if enemy piece */
            }                   /* else */
        }                       /* if not pinned */
    }                           /* for dir */
    return (False);
}                               /* PawnCanMove */


/*----------------------------------------------------------------------
 | GenerateKnightMoves						940422
 |
 | Generates all legal knight moves.
 +----------------------------------------------------------------------*/
static          Boolean
                KnightCanMove(BoardIndexType from)
{
    Signed2         i;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < MaxKnightMoves; i++) {
        to = knightTable[from][i];
        if (!to) {
            break;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            return (True);
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            return (True);
        }
    }
    return (False);
}                               /* KnightCanMove */


/*----------------------------------------------------------------------
 | GenerateBishopMoves						940422
 |
 | Generates all legal bishop moves.
 +----------------------------------------------------------------------*/
static          Boolean
                BishopCanMove(BoardIndexType from)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == bishopDir[i] ||
            pinned[from] == -bishopDir[i]) {
            for (j = 0; j < MaxBishopMoves; j++) {
                to = bishopTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    return (True);
                } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    return (True);
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
    return (False);
}                               /* BishopCanMove */


/*----------------------------------------------------------------------
 | GenerateRookMoves						940422
 |
 | Generates all legal rook moves.
 +----------------------------------------------------------------------*/
static          Boolean
                RookCanMove(BoardIndexType from)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == rookDir[i] ||
            pinned[from] == -rookDir[i]) {
            for (j = 0; j < MaxRookMoves; j++) {
                to = rookTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    return (True);
                } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    return (True);
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
    return (False);
}                               /* RookCanMove */


/*----------------------------------------------------------------------
 | GenerateKingMoves						940422
 |
 | Generates all legal king moves.
 +----------------------------------------------------------------------*/
static          Boolean
                KingCanMove(BoardIndexType from)
{
    Signed2         i;
    BoardIndexType  to;
    BoardIndexType  square1,
		            square2,
                    square3,
                    square4,
                    square5,
                    square6;
    SquareType      piece;

    /* Remove king temporarily in view of Attacked() */
    board[kingSquare[toMove]] = Empty;
    for (i = 0; i < 4; i++) {
        to = rookTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            if (!IsCheckingDir(rookDir[i]) &&
                !IsCheckingDir(-rookDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                board[kingSquare[toMove]] = King | toMove;
                return (True);
            }
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-rookDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                board[kingSquare[toMove]] = King | toMove;
                return (True);
            }
        }
    }
    for (i = 0; i < 4; i++) {
        to = bishopTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            if (!IsCheckingDir(bishopDir[i]) &&
                !IsCheckingDir(-bishopDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                board[kingSquare[toMove]] = King | toMove;
                return (True);
            }
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-bishopDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                board[kingSquare[toMove]] = King | toMove;
                return (True);
            }
        }
    }
    /* Castling */

        if (ShortCastlingPossible()) {
        if (!nrCheck ) {
        if (IsWhite(toMove)) {
            square1 = E1;
			square2 = F1;
            square3 = G1;
            square4 = D1;
            square5 = C1;
            square6 = B1;
        } else {
            square1 = E8;
			square2 = F8;
            square3 = G8;
            square4 = D8;
            square5 = C8;
            square6 = B8;
        }
                        
       if (IsEmpty(board[square2]) && IsEmpty(board[square3]) &&
  	       !Attacked(square2, (SquareType) ! toMove) &&
           !Attacked(square3, (SquareType) ! toMove)) {
           board[kingSquare[toMove]] = King | toMove;
           return (True);
        }
        }}
   
        
        if (LongCastlingPossible()) {
        if (!nrCheck ) {
        if (IsWhite(toMove)) {
            square1 = E1;
			square2 = F1;
            square3 = G1;
            square4 = D1;
            square5 = C1;
            square6 = B1;
        } else {
            square1 = E8;
			square2 = F8;
            square3 = G8;
            square4 = D8;
            square5 = C8;
            square6 = B8;
        }                       
                                   
        if (IsEmpty(board[square4]) && IsEmpty(board[square5]) &&
            IsEmpty(board[square6]) &&
			!Attacked(square4, (SquareType) ! toMove) &&
            !Attacked(square5, (SquareType) ! toMove) &&
            !Attacked(square6, (SquareType) ! toMove)) {
            board[kingSquare[toMove]] = King | toMove;
			return (True);
        }}}
        
        
        
        
    
    board[kingSquare[toMove]] = King | toMove;
  //  return (False);
  return (True);

}                               /* GenerateKingMoves */


/*----------------------------------------------------------------------
 | GenerateCaptureMoves						940428
 |
 | Generate moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 | NOTE: no king capture moves are generated because they are generated
 | later in GenerateKingMoves().
 +----------------------------------------------------------------------*/
static          Boolean
                CaptureMovesAvailable(CheckPieceType * piece)
{
    if (PawnCaptureMovesAvailable(piece)) {
        return (True);
    }
    if (KnightCaptureMovesAvailable(piece)) {
        return (True);
    }
    if (BishopCaptureMovesAvailable(piece)) {
        return (True);
    }
    return (RookCaptureMovesAvailable(piece));
}                               /* CaptureMovesAvailable */


/*----------------------------------------------------------------------
 | GeneratePawnCaptureMoves					940428
 |
 | Generate pawn moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static          Boolean
                PawnCaptureMovesAvailable(CheckPieceType * piece)
{
    Signed2         dir;
    BoardIndexType  from,
                    to;

    to = piece->square;
    /* Normal capture */
    for (dir = 0; dir < 2; dir++) {
        if (pawnCaptureDir[!toMove][dir] == -piece->dir) {
            continue;
        }
        from = pawnCaptureTable[!toMove][to][dir];
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
                             pinned[from] == pawnCaptureDir[!toMove][dir] ||
                           pinned[from] == -pawnCaptureDir[!toMove][dir])) {
            return (True);
        }
    }                           /* for dir */

    /* En passant */
    dir = toMove == White ? Up : Down;
    if (epSquare[nrGamePlies] == to + dir) {
        from = to + Right;
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
             pinned[from] == dir + Right || pinned[from] == -dir - Right)) {
            return (True);
        }                       /* if not pinned */
        from = to + Left;
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
               pinned[from] == dir + Left || pinned[from] == -dir - Left)) {
            return (True);
        }                       /* if not pinned */
    }                           /* if */
    return (False);
}                               /* PawnCaptureMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateKnightCaptureMoves					940428
 |
 | Generate knight moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static          Boolean
                KnightCaptureMovesAvailable(CheckPieceType * piece)
{
    Signed2         i;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < MaxKnightMoves; i++) {
        if (knightDir[i] == -piece->dir) {
            continue;
        }
        from = knightTable[to][i];
        if (!from) {
            break;
        }
        if (board[from] == (Knight | toMove) && !pinned[from]) {
            return (True);
        }
    }
    return (False);
}                               /* KnightCaptureMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateBishopCaptureMoves					940428
 |
 | Generate bishop moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static          Boolean
                BishopCaptureMovesAvailable(CheckPieceType * piece)
{
    Signed2         i,
                    j;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < 4; i++) {
        if (bishopDir[i] == -piece->dir) {
            continue;
        }
        for (j = 0; j < MaxBishopMoves; j++) {
            from = bishopTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Bishop | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == bishopDir[i] ||
                 pinned[from] == -bishopDir[i])) {
                return (True);
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
    return (False);
}                               /* BishopCaptureMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateRookCaptureMoves					940428
 |
 | Generate rook moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static          Boolean
                RookCaptureMovesAvailable(CheckPieceType * piece)
{
    Signed2         i,
                    j;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < 4; i++) {
        if (rookDir[i] == -piece->dir) {
            continue;
        }
        for (j = 0; j < MaxRookMoves; j++) {
            from = rookTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Rook | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == rookDir[i] ||
                 pinned[from] == -rookDir[i])) {
                return (True);
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
    return (False);
}                               /* RookCaptureMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateInterposingMoves					940428
 |
 | Generate moves for color 'toMove' to disable check by interposing
 | a piece.
 +----------------------------------------------------------------------*/
static          Boolean
                InterposingMovesAvailable(CheckPieceType * piece)
{
    BoardIndexType  to;
    DirectionType   dir;

    dir = piece->dir;
    for (to = kingSquare[toMove] + dir; to != piece->square; to += dir) {
        if (ToMovesAvailable(to)) {
            return (True);
        }
    }                           /* for square */
    return (False);
}                               /* InterposingMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateToMoves						940428
 |
 | Generates moves for color 'toMove' to empty square 'to'.
 | NOTE: no king moves are generated.
 +----------------------------------------------------------------------*/
static          Boolean
                ToMovesAvailable(BoardIndexType to)
{
    if (PawnToMovesAvailable(to)) {
        return (True);
    }
    if (KnightToMovesAvailable(to)) {
        return (True);
    }
    if (BishopToMovesAvailable(to)) {
        return (True);
    }
    return (RookToMovesAvailable(to));
}                               /* ToMovesAvailable */


/*----------------------------------------------------------------------
 | GeneratePawnToMoves						940428
 |
 | Generates pawn moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static          Boolean
                PawnToMovesAvailable(BoardIndexType to)
{
    Signed2         dir;
    BoardIndexType  from;

    for (dir = 0; dir < 2; dir++) {
        from = pawnMoveTable[!toMove][to][dir];
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
                              pinned[from] == Up || pinned[from] == Down)) {
            return (True);
        }
    }                           /* for dir */
    return (False);
}                               /* PawnToMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateKnightToMoves						940428
 |
 | Generates knight moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static          Boolean
                KnightToMovesAvailable(BoardIndexType to)
{
    Signed2         i;
    BoardIndexType  from;

    for (i = 0; i < MaxKnightMoves; i++) {
        from = knightTable[to][i];
        if (!from) {
            break;
        }
        if (board[from] == (Knight | toMove) && !pinned[from]) {
            return (True);
        }
    }
    return (False);
}                               /* KnightToMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateBishopToMoves					940428
 |
 | Generates bishop moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static          Boolean
                BishopToMovesAvailable(BoardIndexType to)
{
    Signed2         i,
                    j;
    BoardIndexType  from;

    for (i = 0; i < 4; i++) {
        for (j = 0; j < MaxBishopMoves; j++) {
            from = bishopTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Bishop | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == bishopDir[i] ||
                 pinned[from] == -bishopDir[i])) {
                return (True);
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
    return (False);
}                               /* BishopToMovesAvailable */


/*----------------------------------------------------------------------
 | GenerateRookToMoves						940428
 |
 | Generates rook moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static          Boolean
                RookToMovesAvailable(BoardIndexType to)
{
    Signed2         i,
                    j;
    BoardIndexType  from;

    for (i = 0; i < 4; i++) {
        for (j = 0; j < MaxRookMoves; j++) {
            from = rookTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Rook | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == rookDir[i] ||
                 pinned[from] == -rookDir[i])) {
                return (True);
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
    return (False);
}                               /* RookToMovesAvailable */





/*----------------------------------------- -----------------------------
 | GENERATE							940422
 |
 | Contains all move generation procedures.
 +----------------------------------------------------------------------*/

static void     GeneratePawnMoves(BoardIndexType square, MoveType * list,
                                                  Unsigned1 * nrMoves);
static void     GenerateKnightMoves(BoardIndexType square, MoveType * list,
                                                    Unsigned1 * nrMoves);
static void     GenerateBishopMoves(BoardIndexType square, MoveType * list,
                                                    Unsigned1 * nrMoves);
static void     GenerateRookMoves(BoardIndexType square, MoveType * list,
                                                  Unsigned1 * nrMoves);
static void     GeneratePawnCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateKnightCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateBishopCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateRookCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateToMoves(BoardIndexType to, MoveType * list,
                                                Unsigned1 * nrMoves);
static void     GeneratePawnToMoves(BoardIndexType to, MoveType * list,
                                                    Unsigned1 * nrMoves);
static void     GenerateKnightToMoves(BoardIndexType to, MoveType * list,
                                                      Unsigned1 * nrMoves);
static void     GenerateBishopToMoves(BoardIndexType to, MoveType * list,
                                                      Unsigned1 * nrMoves);
static void     GenerateRookToMoves(BoardIndexType to, MoveType * list,
                                                    Unsigned1 * nrMoves);
static void     SiftUp(MoveType * moveList, Unsigned1 root, Unsigned1 leaf);


/*----------------------------------------------------------------------
 | GenerateMoves						940422
 |
 | Generates all legal moves.
 +----------------------------------------------------------------------*/
void            GenerateMoves(MoveType ** moveList, Unsigned1 * nrMoves)
{
    PieceType      *pieceTable;
    Unsigned1       nr;
    SquareType      piece;
    Signed2         i;
    MoveType        list[MaxMoves];

    pieceTable = pieces[toMove];
    nr = nrPieces[toMove];

    *nrMoves = 0;
    SearchForPinsAndCheck();
    switch (nrCheck) {
    case 0:
        for (i = 0; i < nr; i++) {
            piece = pieceTable[i].type;
            if (IsPawn(piece)) {
                GeneratePawnMoves(pieceTable[i].square, list, nrMoves);
            } else if (IsKnight(piece) && !pinned[pieceTable[i].square]) {
                GenerateKnightMoves(pieceTable[i].square, list, nrMoves);
            } else if (IsKing(piece)) {
                GenerateKingMoves(pieceTable[i].square, list, nrMoves);
            } else {
                if (MovesDiagonal(piece)) {
                    GenerateBishopMoves(pieceTable[i].square, list, nrMoves);
                }
                if (MovesStraight(piece)) {
                    GenerateRookMoves(pieceTable[i].square, list, nrMoves);
                }
            }
        }                       /* for i */
        break;
    case 1:
        /* Capture check-giving piece, NOT with king */
        GenerateCaptureMoves(&(checkingPiece[0]), list, nrMoves);
        /* Interpose piece */
        if (checkingPiece[0].dir &&
            kingSquare[toMove] + checkingPiece[0].dir !=
            checkingPiece[0].square) {
            GenerateInterposingMoves(&(checkingPiece[0]), list, nrMoves);
        }
    case 2:
        /* Move king away, including trying to capture (one of) the
         * check-giving piece(s) */
        GenerateKingMoves(kingSquare[toMove], list, nrMoves);
        break;
    default:
        printf("ERROR: %d times in check\n", nrCheck);
        exit(0);
    }                           /* switch */
    if (*nrMoves) {
        AllocateMoveList(*moveList, *nrMoves);
        memcpy(*moveList, list, *nrMoves * sizeof(MoveType));
    }
/*  HeapSort( *moveList, *nrMoves );
   qsort( *moveList, *nrMoves, sizeof( MoveType ), CompareMoves ); */
    nrGenerates++;
    nrMovesGenerated += *nrMoves;
}                               /* GenerateMoves */


/*----------------------------------------------------------------------
 | GeneratePawnMoves						940420
 |
 | Generates all legal pawn moves.
 +----------------------------------------------------------------------*/
static void     GeneratePawnMoves(BoardIndexType from, MoveType * list,
                                                  Unsigned1 * nrMoves)
{
    BoardIndexType  to;
    SquareType      piece;
    Unsigned1       dir;
    PieceType       attackingPiece;

    /* non-capture moves */
    if (!pinned[from] || pinned[from] == Up || pinned[from] == Down) {
        to = pawnMoveTable[toMove][from][0];
        if (IsEmpty(board[to])) {
            if (OnSeventhRank(toMove, from)) {
                PutMoveInTable(from, to, 0, Queen | toMove, Promotion, list,
                               *nrMoves);
                PutMoveInTable(from, to, 0, Knight | toMove, Promotion, list,
                               *nrMoves);
                PutMoveInTable(from, to, 0, Rook | toMove, Promotion, list,
                               *nrMoves);
                PutMoveInTable(from, to, 0, Bishop | toMove, Promotion, list,
                               *nrMoves);
            } else {
                PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
            }
            to = pawnMoveTable[toMove][from][1];
            if (IsEmpty(board[to])) {
                PutMoveInTable(from, to, 0, 0, Double, list, *nrMoves);
            }
        }                       /* if empty square */
    }                           /* if not pinned */
    /* capture moves */
    for (dir = 0; dir < 2; dir++) {
        if (!pinned[from] || pinned[from] == pawnCaptureDir[toMove][dir] ||
            pinned[from] == -pawnCaptureDir[toMove][dir]) {
            to = pawnCaptureTable[toMove][from][dir];
            if (to == epSquare[nrGamePlies]) {
                if (Rank(kingSquare[toMove]) != (toMove == White ? 5 : 4)) {
                    PutMoveInTable(from, to, Pawn | !toMove, 0,
                                   EnPassant | Capture, list, *nrMoves);
                } else {
                    /* remove pawns temporarily */
                    board[from] = Empty;
                    board[to + (toMove == White ? Down : Up)] = Empty;
                    if (!FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                       rookTable[kingSquare[toMove]][2], &attackingPiece) ||
                        (attackingPiece.type != (Rook | !toMove) &&
                         attackingPiece.type != (Queen | !toMove))) {
                        if (!FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                        rookTable[kingSquare[toMove]][3], &attackingPiece) ||
                            (attackingPiece.type != (Rook | !toMove) &&
                             attackingPiece.type != (Queen | !toMove))) {
                            PutMoveInTable(from, to, Pawn | !toMove, 0,
                                       EnPassant | Capture, list, *nrMoves);
                        }
                    }
                    /* Put pawns back */
                    board[from] = Pawn | toMove;
                    board[to + (toMove == White ? Down : Up)] = Pawn | !toMove;
                }
            } else {
                piece = board[to];
                if (piece && !IsEdge(piece) && !IsColor(piece, toMove)) {
                    if (OnSeventhRank(toMove, from)) {
                        PutMoveInTable(from, to, piece, Queen | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Knight | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Rook | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Bishop | toMove,
                                       Promotion | Capture, list, *nrMoves);
                    } else {
                        PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    }
                }               /* if enemy piece */
            }                   /* else */
        }                       /* if not pinned */
    }                           /* for dir */
}                               /* GeneratePawnMoves */


/*----------------------------------------------------------------------
 | GenerateKnightMoves						940422
 |
 | Generates all legal knight moves.
 +----------------------------------------------------------------------*/
static void     GenerateKnightMoves(BoardIndexType from, MoveType * list,
                                                    Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < MaxKnightMoves; i++) {
        to = knightTable[from][i];
        if (!to) {
            break;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
        }
    }
}                               /* GenerateKnightMoves */


/*----------------------------------------------------------------------
 | GenerateBishopMoves						940422
 |
 | Generates all legal bishop moves.
 +----------------------------------------------------------------------*/
static void     GenerateBishopMoves(BoardIndexType from, MoveType * list,
                                                    Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == bishopDir[i] ||
            pinned[from] == -bishopDir[i]) {
            for (j = 0; j < MaxBishopMoves; j++) {
                to = bishopTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
                } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    break;
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
}                               /* GenerateBishopMoves */


/*----------------------------------------------------------------------
 | GenerateRookMoves						940422
 |
 | Generates all legal rook moves.
 +----------------------------------------------------------------------*/
static void     GenerateRookMoves(BoardIndexType from, MoveType * list,
                                                  Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == rookDir[i] ||
            pinned[from] == -rookDir[i]) {
            for (j = 0; j < MaxRookMoves; j++) {
                to = rookTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
                } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    break;
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
}                               /* GenerateRookMoves */


/*----------------------------------------------------------------------
 | GenerateKingMoves						940422
 |
 | Generates all legal king moves.
 +----------------------------------------------------------------------*/
void            GenerateKingMoves(BoardIndexType from, MoveType * list,
                                                  Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  to;
    BoardIndexType  square1,
                    square2,
                    square3,
                    square4,
                    square5,
                    square6;
    SquareType      piece;

    /* Remove king temporarily in view of Attacked() */
    board[kingSquare[toMove]] = Empty;
    for (i = 0; i < 4; i++) {
        to = rookTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            if (!IsCheckingDir(rookDir[i]) &&
                !IsCheckingDir(-rookDir[i]) &&
                !Attacked(to, (Unsigned1) ! toMove)) {
                PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
            }
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-rookDir[i]) &&
                !Attacked(to, (Unsigned1) ! toMove)) {
                PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
            }
        }
    }
    for (i = 0; i < 4; i++) {
        to = bishopTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        if (IsEmpty(piece)) {
            if (!IsCheckingDir(bishopDir[i]) &&
                !IsCheckingDir(-bishopDir[i]) &&
                !Attacked(to, (Unsigned1) ! toMove)) {
                PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
            }
        } else if (!IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-bishopDir[i]) &&
                !Attacked(to, (Unsigned1) ! toMove)) {
                PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
            }
        }
    }
    /* Castling */

		if (ShortCastlingPossible()) { 
        if (!nrCheck ) {
        if (IsWhite(toMove)) {
            square1 = E1;
            square2 = F1;
            square3 = G1;
            square4 = D1;
            square5 = C1;
            square6 = B1;
        } else {
            square1 = E8;
            square2 = F8;
            square3 = G8;
            square4 = D8;
            square5 = C8;
            square6 = B8;
        }
		                                                     
        if (IsEmpty(board[square2]) && IsEmpty(board[square3]) &&
			!Attacked(square2, (Unsigned1) ! toMove) &&
            !Attacked(square3, (Unsigned1) ! toMove)) {
			PutMoveInTable(square1, square3, 0, 0, ShortCastle, list, *nrMoves); 
        }}}
        
          
        
        if (LongCastlingPossible()) {
        if (!nrCheck ) {
        if (IsWhite(toMove)) {
            square1 = E1;
            square2 = F1;
            square3 = G1;
            square4 = D1;
            square5 = C1;
            square6 = B1;
        } else {
            square1 = E8;
            square2 = F8;
            square3 = G8;
            square4 = D8;
            square5 = C8;
            square6 = B8;
        }                        
                                                                     
        if (IsEmpty(board[square4]) && IsEmpty(board[square5]) &&
            IsEmpty(board[square6]) &&
			!Attacked(square4, (Unsigned1) ! toMove) &&
            !Attacked(square5, (Unsigned1) ! toMove) &&
            !Attacked(square6, (Unsigned1) ! toMove)) {         
			PutMoveInTable(square1, square5, 0, 0, LongCastle, list, *nrMoves);
			
	
  }}}
                              /* if not in check */
    
      
        board[kingSquare[toMove]] = King | toMove;
        
	
}                               /* GenerateKingMoves */





/*----------------------------------------------------------------------
 | Attacked							940426
 |
 | Checks if square 'square' is attacked by color 'color'.
 +----------------------------------------------------------------------*/
Boolean
Attacked(BoardIndexType square, SquareType color)
{
    Signed2         i;
    PieceType       attackingPiece;
    SquareType      piece;
    BoardIndexType  to;

    /* Attacked by Rook, Bishop or Queen */
    for (i = 0; i < 4; i++) {
        if (FindFirstPieceInDir((Unsigned1) MaxBishopMoves,
                                bishopTable[square][i], &attackingPiece)) {
            if (IsColor(attackingPiece.type, color) &&
                MovesDiagonal(attackingPiece.type)) {
                return (True);
            }
        }
        if (FindFirstPieceInDir((Unsigned1) MaxRookMoves, rookTable[square][i],
                                &attackingPiece)) {
            if (IsColor(attackingPiece.type, color) &&
                MovesStraight(attackingPiece.type)) {
                return (True);
            }
        }
    }
    /* Attacked by Knight */
    for (i = 0; i < 8; i++) {
        to = knightTable[square][i];
        if (!to) {
            break;
        }
        piece = board[to];
        if (IsKnight(piece) && IsColor(piece, color)) {
            return (True);
        }
    }
    /* Attacked by King */
    for (i = 0; i < 4; i++) {
        to = bishopTable[square][i][0];
        if (to) {
            piece = board[to];
            if (IsKing(piece) && IsColor(piece, color)) {
                return (True);
            }
        }
        to = rookTable[square][i][0];
        if (to) {
            piece = board[to];
            if (IsKing(piece) && IsColor(piece, color)) {
                return (True);
            }
        }
    }
    /* Attacked by Pawn */
    to = pawnCaptureTable[!color][square][0];
    if (to) {
        piece = board[to];
        if (IsPawn(piece) && IsColor(piece, color)) {
            return (True);
        }
    }
    to = pawnCaptureTable[!color][square][1];
    if (to) {
        piece = board[to];
        if (IsPawn(piece) && IsColor(piece, color)) {
            return (True);
        }
    }
    return (False);
}                               /* Attacked */


/*----------------------------------------------------------------------
 | FindFirstPieceInDir						940426
 |
 | Searches squares in table 'table' to find a piece. If no piece is
 | found, False is returned.
 +----------------------------------------------------------------------*/
#ifdef Bcc
Boolean
FindFirstPieceInDir(Unsigned1 max, BoardIndexType huge * table,
                    PieceType * attackingPiece)
#else
Boolean
FindFirstPieceInDir(Unsigned1 max, BoardIndexType * table,
                    PieceType * attackingPiece)
#endif
{
    Signed2         i;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < max; i++) {
        to = table[i];
        if (!to) {
            return (False);
        }
        piece = board[to];
        if (!IsEmpty(piece)) {
            break;
        }
    }                           /* for i */
    if (IsEdge(piece)) {
        return (False);
    } else {
        attackingPiece->type = piece;
        attackingPiece->square = to;
        return (True);
    }
}                               /* FindFirstPieceInDir */


/*----------------------------------------------------------------------
 | SearchForPinsAndCheck					940427
 |
 | Checks if side 'toMove' is inCheck and which pieces are pinned and
 | in what direction.
 +----------------------------------------------------------------------*/
void            SearchForPinsAndCheck(void)
{
    BoardIndexType  square,
                    sq,
                    to;
    Signed2         i;
    SquareType      piece;
    PieceType       attackingPiece;

    nrCheck = 0;
    checkingPiece[0].dir = checkingPiece[1].dir = 0;
    for (i = 0; i < nrPieces[toMove]; i++) {
        pinned[pieces[toMove][i].square] = 0;
    }
    square = kingSquare[toMove];
    /* Check or pinned by Rook, Bishop or Queen */
    for (i = 0; i < 4; i++) {
        if (FindFirstPieceInDir((Unsigned1) MaxBishopMoves,
                                bishopTable[square][i], &attackingPiece)) {
            if (IsColor(attackingPiece.type, !toMove)) {
                if (MovesDiagonal(attackingPiece.type)) {
                    checkingPiece[nrCheck].square = attackingPiece.square;
                    checkingPiece[nrCheck++].dir = bishopDir[i];
                }
            } else {
                sq = attackingPiece.square;
                if (FindFirstPieceInDir((Unsigned1) MaxBishopMoves,
                                     bishopTable[sq][i], &attackingPiece) &&
                    IsColor(attackingPiece.type, !toMove)) {
                    if (MovesDiagonal(attackingPiece.type)) {
                        pinned[sq] = bishopDir[i];
                    }
                }               /* pinned */
            }                   /* else */
        }                       /* if piece */
        if (FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                                rookTable[square][i], &attackingPiece)) {
            if (IsColor(attackingPiece.type, !toMove)) {
                if (MovesStraight(attackingPiece.type)) {
                    checkingPiece[nrCheck].square = attackingPiece.square;
                    checkingPiece[nrCheck++].dir = rookDir[i];
                }
            } else {
                sq = attackingPiece.square;
                if (FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                                        rookTable[sq][i], &attackingPiece) &&
                    IsColor(attackingPiece.type, !toMove)) {
                    if (MovesStraight(attackingPiece.type)) {
                        pinned[sq] = rookDir[i];
                    }
                }               /* pinned */
            }                   /* else */
        }                       /* if piece */
    }
    /* Check by Knight */
    for (i = 0; i < 8; i++) {
        to = knightTable[square][i];
        if (!to) {
            break;
        }
        piece = board[to];
        if (IsKnight(piece) && IsColor(piece, !toMove)) {
            checkingPiece[nrCheck].square = to;
            checkingPiece[nrCheck++].dir = 0;
        }
    }
    /* Check by Pawn */
    to = pawnCaptureTable[toMove][square][0];
    if (to) {
        piece = board[to];
        if (IsPawn(piece) && IsColor(piece, !toMove)) {
            checkingPiece[nrCheck].square = to;
            checkingPiece[nrCheck++].dir = 0;
        }
    }
    to = pawnCaptureTable[toMove][square][1];
    if (to) {
        piece = board[to];
        if (IsPawn(piece) && IsColor(piece, !toMove)) {
            checkingPiece[nrCheck].square = to;
            checkingPiece[nrCheck++].dir = 0;
        }
    }

}                               /* SearchForPinsAndCheck */


/*----------------------------------------------------------------------
 | GenerateCaptureMoves						940428
 |
 | Generate moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 | NOTE: no king capture moves are generated because they are generated
 | later in GenerateKingMoves().
 +----------------------------------------------------------------------*/
void            GenerateCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                     Unsigned1 * nrMoves)
{
    GeneratePawnCaptureMoves(piece, list, nrMoves);
    GenerateKnightCaptureMoves(piece, list, nrMoves);
    GenerateBishopCaptureMoves(piece, list, nrMoves);
    GenerateRookCaptureMoves(piece, list, nrMoves);
}                               /* GenerateCaptureMoves */


/*----------------------------------------------------------------------
 | GeneratePawnCaptureMoves					940428
 |
 | Generate pawn moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static void     GeneratePawnCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                         Unsigned1 * nrMoves)
{
    Signed2         dir;
    BoardIndexType  from,
                    to;

    to = piece->square;
    /* Normal capture */
    for (dir = 0; dir < 2; dir++) {
        if (pawnCaptureDir[!toMove][dir] == -piece->dir) {
            continue;
        }
        from = pawnCaptureTable[!toMove][to][dir];
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
                             pinned[from] == pawnCaptureDir[!toMove][dir] ||
                           pinned[from] == -pawnCaptureDir[!toMove][dir])) {
            if (OnSeventhRank(toMove, from)) {
                PutMoveInTable(from, to, board[to], Queen | toMove,
                               Promotion | Capture, list, *nrMoves);
                PutMoveInTable(from, to, board[to], Knight | toMove,
                               Promotion | Capture, list, *nrMoves);
                PutMoveInTable(from, to, board[to], Rook | toMove,
                               Promotion | Capture, list, *nrMoves);
                PutMoveInTable(from, to, board[to], Bishop | toMove,
                               Promotion | Capture, list, *nrMoves);
            } else {
                PutMoveInTable(from, to, board[to], 0, Capture, list,
                               *nrMoves);
            }
        }                       /* if not pinned */
    }                           /* for dir */

    /* En passant */
    dir = toMove == White ? Up : Down;
    if (epSquare[nrGamePlies] == to + dir) {
        from = to + Right;
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
             pinned[from] == dir + Right || pinned[from] == -dir - Right)) {
            PutMoveInTable(from, to + dir, board[to], 0, EnPassant | Capture,
                           list, *nrMoves);
        }                       /* if not pinned */
        from = to + Left;
        if (from && board[from] == (Pawn | toMove) && (!pinned[from] ||
               pinned[from] == dir + Left || pinned[from] == -dir - Left)) {
            PutMoveInTable(from, to + dir, board[to], 0, EnPassant | Capture,
                           list, *nrMoves);
        }                       /* if not pinned */
    }                           /* if */
}                               /* GeneratePawnCaptureMoves */


/*----------------------------------------------------------------------
 | GenerateKnightCaptureMoves					940428
 |
 | Generate knight moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static void     GenerateKnightCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                        Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < MaxKnightMoves; i++) {
        if (knightDir[i] == -piece->dir) {
            continue;
        }
        from = knightTable[to][i];
        if (!from) {
            break;
        }
        if (board[from] == (Knight | toMove) && !pinned[from]) {
            PutMoveInTable(from, to, board[to], 0, Capture, list, *nrMoves);
        }
    }
}                               /* GenerateKnightCaptureMoves */


/*----------------------------------------------------------------------
 | GenerateBishopCaptureMoves					940428
 |
 | Generate bishop moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static void     GenerateBishopCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                        Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < 4; i++) {
        if (bishopDir[i] == -piece->dir) {
            continue;
        }
        for (j = 0; j < MaxBishopMoves; j++) {
            from = bishopTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Bishop | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == bishopDir[i] ||
                 pinned[from] == -bishopDir[i])) {
                PutMoveInTable(from, to, board[to], 0, Capture, list, *nrMoves);
                break;
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
}                               /* GenerateBishopCaptureMoves */


/*----------------------------------------------------------------------
 | GenerateRookCaptureMoves					940428
 |
 | Generate rook moves for color 'toMove', trying to disable check by
 | capturing the check-giving piece.
 +----------------------------------------------------------------------*/
static void     GenerateRookCaptureMoves(CheckPieceType * piece, MoveType * list,
                                                         Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  from,
                    to;

    to = piece->square;
    for (i = 0; i < 4; i++) {
        if (rookDir[i] == -piece->dir) {
            continue;
        }
        for (j = 0; j < MaxRookMoves; j++) {
            from = rookTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Rook | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == rookDir[i] ||
                 pinned[from] == -rookDir[i])) {
                PutMoveInTable(from, to, board[to], 0, Capture, list, *nrMoves);
                break;
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
}                               /* GenerateRookCaptureMoves */


/*----------------------------------------------------------------------
 | GenerateInterposingMoves					940428
 |
 | Generate moves for color 'toMove' to disable check by interposing
 | a piece.
 +----------------------------------------------------------------------*/
void            GenerateInterposingMoves(CheckPieceType * piece, MoveType * list,
                                                         Unsigned1 * nrMoves)
{
    BoardIndexType  to;
    DirectionType   dir;

    dir = piece->dir;
    for (to = kingSquare[toMove] + dir; to != piece->square; to += dir) {
        GenerateToMoves(to, list, nrMoves);
    }                           /* for square */
}                               /* GenerateInterposingMoves */


/*----------------------------------------------------------------------
 | GenerateToMoves						940428
 |
 | Generates moves for color 'toMove' to empty square 'to'.
 | NOTE: no king moves are generated.
 +----------------------------------------------------------------------*/
static void     GenerateToMoves(BoardIndexType to, MoveType * list,
                                                Unsigned1 * nrMoves)
{
    GeneratePawnToMoves(to, list, nrMoves);
    GenerateKnightToMoves(to, list, nrMoves);
    GenerateBishopToMoves(to, list, nrMoves);
    GenerateRookToMoves(to, list, nrMoves);
}                               /* GenerateToMoves */


/*----------------------------------------------------------------------
 | GeneratePawnToMoves						940428
 |
 | Generates pawn moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static void     GeneratePawnToMoves(BoardIndexType to, MoveType * list,
                                                    Unsigned1 * nrMoves)
{
    BoardIndexType  from;
    Unsigned1       type;

    from = pawnMoveTable[!toMove][to][0];
    /* Move from second rank? */
    if (IsEmpty(board[from]) &&
        Rank(from) == (IsWhite(toMove) ? 3 : 6)) {
        from = pawnMoveTable[!toMove][from][0];
        type = Double;
    } else {
        type = Normal;
    }
    if (board[from] == (Pawn | toMove) && (!pinned[from] ||
                              pinned[from] == Up || pinned[from] == Down)) {
        if (OnSeventhRank(toMove, from)) {
            PutMoveInTable(from, to, 0, Queen | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Knight | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Rook | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Bishop | toMove, Promotion, list,
                           *nrMoves);
        } else {
            PutMoveInTable(from, to, 0, 0, type, list, *nrMoves);
        }
    }                           /* if not pinned */
}                               /* GeneratePawnToMoves */


/*----------------------------------------------------------------------
 | GenerateKnightToMoves						940428
 |
 | Generates knight moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static void     GenerateKnightToMoves(BoardIndexType to, MoveType * list,
                                                      Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  from;

    for (i = 0; i < MaxKnightMoves; i++) {
        from = knightTable[to][i];
        if (!from) {
            break;
        }
        if (board[from] == (Knight | toMove) && !pinned[from]) {
            PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
        }
    }
}                               /* GenerateKnightToMoves */


/*----------------------------------------------------------------------
 | GenerateBishopToMoves					940428
 |
 | Generates bishop moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static void     GenerateBishopToMoves(BoardIndexType to, MoveType * list,
                                                      Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  from;

    for (i = 0; i < 4; i++) {
        for (j = 0; j < MaxBishopMoves; j++) {
            from = bishopTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Bishop | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == bishopDir[i] ||
                 pinned[from] == -bishopDir[i])) {
                PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
                break;
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
}                               /* GenerateBishopToMoves */


/*----------------------------------------------------------------------
 | GenerateRookToMoves						940428
 |
 | Generates rook moves for color 'toMove' to empty square 'to'.
 +----------------------------------------------------------------------*/
static void     GenerateRookToMoves(BoardIndexType to, MoveType * list,
                                                    Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  from;

    for (i = 0; i < 4; i++) {
        for (j = 0; j < MaxRookMoves; j++) {
            from = rookTable[to][i][j];
            if (!from) {
                break;
            }
            if (IsEmpty(board[from])) {
                continue;
            }
            if ((board[from] == (Rook | toMove) || board[from] == (Queen | toMove)) &&
                (!pinned[from] || pinned[from] == rookDir[i] ||
                 pinned[from] == -rookDir[i])) {
                PutMoveInTable(from, to, 0, 0, Normal, list, *nrMoves);
                break;
            } else {
                break;
            }
        }                       /* for j */
    }                           /* for i */
}                               /* GenerateRookToMoves */


Signed2
CompareMoves(MoveType * move1, MoveType * move2)
{
/*
   Signed2      diff1, diff2;
   Signed2      *eval1Table, *eval2Table;
 */
    if (move1->to == lastMovedPieceSquare &&
        move2->to == lastMovedPieceSquare) {
        goto sameCapture;
    }
    if (move1->to == lastMovedPieceSquare) {
        return (-1);
    }
    if (move2->to == lastMovedPieceSquare) {
        return (1);
    }
    /* Promotion moves */
    if (move1->promotionPiece > move2->promotionPiece) {
        return (-1);
    }
    if (move1->promotionPiece < move2->promotionPiece) {
        return (1);
    }
    /* Capture moves */
    if (move1->capturedPiece > move2->capturedPiece) {
        return (-1);
    }
    if (move1->capturedPiece < move2->capturedPiece) {
        return (1);
    }
/*
   if (pieceValue[ move1->capturedPiece ]-pieceValue[ board[ move1->from ] ]>
   pieceValue[ move2->capturedPiece ]-pieceValue[ board[ move2->from ] ]) {
   return( -1 );
   }
   if (pieceValue[ move1->capturedPiece ]-pieceValue[ board[ move1->from ] ]<
   pieceValue[ move2->capturedPiece ]-pieceValue[ board[ move2->from ] ]) {
   return( 1 );
   }
 */
sameCapture:
    if (board[move1->from] < board[move2->from]) {
        return (-1);
    }
    if (board[move1->from] > board[move2->from]) {
        return (1);
    }
    /* History heuristic */
    if (historyTable[toMove][move1->from][move1->to] >
        historyTable[toMove][move2->from][move2->to]) {
        return (-1);
    }
    if (historyTable[toMove][move1->from][move1->to] <
        historyTable[toMove][move2->from][move2->to]) {
        return (1);
    }
/*
   GetEvalTable( eval1Table, toMove, board[ move1->from ] );
   GetEvalTable( eval2Table, toMove, board[ move2->from ] );
   diff1 = eval1Table[ move1->to ] - eval1Table[ move1->from ];
   diff2 = eval2Table[ move2->to ] - eval2Table[ move2->from ];
   if (diff1 > diff2) {
   return( -1 );
   }
   if (diff1 < diff2) {
   return( 1 );
   }
 */
    return (0);
}                               /* CompareMoves */


void            HeapSort(MoveType * moveList, Unsigned1 nrMoves)
{
    Unsigned1       i;
    MoveType        temp;

    /* Construct heap */
    for (i = nrMoves / 2 - 1; i > 0; i--) {
        SiftUp(moveList, (Unsigned1) i, (Unsigned1) (nrMoves - 1));
    }
    /* Iterate */
    for (i = nrMoves - 1; i > 0; i--) {
        SiftUp(moveList, (Unsigned1) 0, (Unsigned1) i);
        temp = moveList[0];
        moveList[0] = moveList[i];
        moveList[i] = temp;
    }
}                               /* HeapSort */


static void     SiftUp(MoveType * moveList, Unsigned1 root, Unsigned1 leaf)
{
    Unsigned1       i;
    MoveType        temp;

    for (temp = moveList[root];;) {
        i = 2 * root + 1;       /* Left child */
        if (i <= leaf) {
            if (i < leaf) {
                if (CompareMoves(&(moveList[i + 1]), &(moveList[i])) == 1) {
                    i++;        /* Right child */
                }
            }
            if (CompareMoves(&(moveList[i]), &temp) == 1) {
                moveList[root] = moveList[i];
                root = i;
            } else {
                break;
            }
        } else {
            break;
        }
    }
    moveList[root] = temp;
}                               /* SiftUp */


void            SiftDown(MoveType * moveList, Unsigned1 root, Unsigned1 leaf)
{
    Unsigned1       i;
    MoveType        temp;

    for (temp = moveList[root];;) {
        i = 2 * root + 1;       /* Left child */
        if (i <= leaf) {
            if (i < leaf) {
                if (CompareMoves(&(moveList[i + 1]), &(moveList[i])) == -1) {
                    i++;        /* Right child */
                }
            }
            if (CompareMoves(&(moveList[i]), &temp) == -1) {
                moveList[root] = moveList[i];
                root = i;
            } else {
                break;
            }
        } else {
            break;
        }
    }
    moveList[root] = temp;
}                               /* SiftDown */































/*----------------------------------------------------------------------
 | IO							940420
 |
 | Contains the I/O-routines.
 +----------------------------------------------------------------------*/




static int CDECL CompareHistory(const void *h1, const void *h2);


/*----------------------------------------------------------------------
 | PrintBoard							940421
 |
 | Prints the board.
 +----------------------------------------------------------------------*/
void            PrintBoard(void)
{
    Signed2         i,
                    j;
    SquareType      square;
    char            s[MaxCommandLength];

    printf("%s\t", moveColorString[toMove]);
    if (epSquare[nrGamePlies] != NoEp) {
        SPrintSquare(s, epSquare[nrGamePlies]);
        printf("%s\t", s);
    }
    if (castling[nrGamePlies] & WhiteShort) {
        printf("WS ");
    }
    if (castling[nrGamePlies] & WhiteLong) {
        printf("WL ");
    }
    if (castling[nrGamePlies] & BlackShort) {
        printf("BS ");
    }
    if (castling[nrGamePlies] & BlackLong) {
        printf("BL ");
    }
    printf("%ld%c%d %ld%c%d", material[White],
        positionalValue[White] < 0 ? '-' : '+', abs(positionalValue[White]),
           material[Black], positionalValue[Black] < 0 ? '-' : '+',
           abs(positionalValue[Black]));
    printf("\t(%lx,%lx)", hashValue[nrGamePlies][0],
           hashValue[nrGamePlies][1]);
    printf("\n  +------------------------+\n");
    for (i = 8; i >= 1; i--) {
        printf("%d |", i);
        for (j = A; j <= H; j++) {
            square = Square(j, i);
            if (WhiteSquare(j, i)) {
                printf(":");
            } else {
                printf(" ");
            }
            if (IsEmpty(board[square])) {
                if (WhiteSquare(j, i)) {
                    printf(":");
                } else {
                    printf(" ");
                }
            } else {
                printf("%c", pieceSymbol[board[square]]);
            }
            if (WhiteSquare(j, i)) {
                printf(":");
            } else {
                printf(" ");
            }
        }                       /* for j */
        printf("|\n");
    }                           /* for i */
    printf("  +------------------------+\n");
    printf("    A  B  C  D  E  F  G  H\n");
}                               /* PrintBoard */


/*----------------------------------------------------------------------
 | PrintMoveList						940425
 |
 | Prints all moves from a move list.
 +----------------------------------------------------------------------*/
void            PrintMoveList(MoveType * list, Unsigned1 nrMoves)
{
    Signed2         i;
    char            s[MaxCommandLength];

    for (i = 0; i < nrMoves; i++) {
        SPrintMove(s, list[i]);
        printf("%s ", s);
    }
/*
   printf( "\n\nSorted:\n" );
   HeapSort( list, nrMoves );
   for (i=0; i<nrMoves; i++) {
   SPrintMove( s, list[ i ] );
   printf( "%s ", s );
   }
 */
    printf("\n");
}                               /* PrintMoveList */


/*----------------------------------------------------------------------
 | PrintAllocVariables						940425
 |
 | Prints all allocate variables.
 +----------------------------------------------------------------------*/
void            PrintAllocVariables(void)
{
    printf("Allocated move lists: %d\n", nrAllocMoveLists);
    printf("Allocated path moves: %d\n", nrAllocPathMoves);
}                               /* PrintAllocVariables */


void            PrintGame(Signed2 from, Signed2 to)
{
    Signed2         i;

    for (i = from; i <= to; i++) {
        if (i % 2 == 0) {
            printf("%3d.", i / 2 + 1);
        }
        printf(" %s", gameString[i]);
        if (i % 8 == 7) {
            printf("\n");
        }
    }
    printf("\n");
}                               /* PrintGame */


/*----------------------------------------------------------------------
 | PrintPath							940506
 |
 | Prints a move path.
 +----------------------------------------------------------------------*/
void            PrintPath(PathType * path)
{
    PathType       *ptr;
    Signed2         i,
                    j;

    if (path == NULL) {
        return;
    }
    for (i = 0, ptr = path; ptr != NULL; ptr = ptr->next, i++) {
        if (i && !(i % 6)) {
            printf("\n                     ");
        }
        printf("%-8s", ptr->moveString);
    }
    for (j = 0; j < (6 - i % 6) % 6; j++) {
        printf("        ");
    }
  //  printf("%d", i);
}                               /* PrintPath */


void            PrintHistoryTable(void)
{
    BoardIndexType  i,
                    j;
    char            s[4];
    Unsigned2       nrHistoryMoves;
    History         table[500];

    printf("White:\n");
    nrHistoryMoves = 0;
    for (i = A1; i <= H8; i++) {
        for (j = A1; j <= H8; j++) {
            if (historyTable[White][i][j] != 0) {
                table[nrHistoryMoves].from = i;
                table[nrHistoryMoves].to = j;
                table[nrHistoryMoves++].nr = historyTable[White][i][j];
            }
        }
    }
    qsort(table, nrHistoryMoves, sizeof(History), CompareHistory);
    for (i = 0; i < (BoardIndexType) nrHistoryMoves; i++) {
        SPrintSquare(s, table[i].from);
        printf("%s", s);
        SPrintSquare(s, table[i].to);
        printf("%s%5d,", s, table[i].nr);
    }

    printf("\n\nBlack:\n");
    nrHistoryMoves = 0;
    for (i = A1; i <= H8; i++) {
        for (j = A1; j <= H8; j++) {
            if (historyTable[Black][i][j] != 0) {
                table[nrHistoryMoves].from = i;
                table[nrHistoryMoves].to = j;
                table[nrHistoryMoves++].nr = historyTable[Black][i][j];
            }
        }
    }
    qsort(table, nrHistoryMoves, sizeof(History), CompareHistory);
    for (i = 0; i < (BoardIndexType) nrHistoryMoves; i++) {
        SPrintSquare(s, table[i].from);
        printf("%s", s);
        SPrintSquare(s, table[i].to);
        printf("%s%5d,", s, table[i].nr);
    }
}                               /* PrintHistoryTable */


static int      CDECL
                CompareHistory(const void *his1, const void *his2)
{
    History        *h1,
                   *h2;

    h1 = (History *) his1;
    h2 = (History *) his2;
    if (h1->nr < h2->nr) {
        return (1);
    }
    if (h1->nr > h2->nr) {
        return (-1);
    }
    return (0);
}                               /* CompareHistory */


void            PrintHashes(void)
{
    Signed2         i;

    for (i = nrGamePlies; i >= startHashIndex[nrGamePlies]; i--) {
        printf("%3d: %x, %x\n", i, hashValue[i][0], hashValue[i][1]);
    }
}                               /* PrintHashes */


void            PrintSettings(void)
{
    printf("\nSettings\n");
    printf("--------\n");
    printf("Refutation table   : %s\n", logicString[useRefTable]);
    printf("Transposition table: %s\n", logicString[useTransTable]);
    if (useTransTable) {
        printf("\nClearing entries with age %d ply\n", keepPly + 1);
        printf("Keepmethod   : %s\n", methodString[keepMethod]);
        printf("TwoLevelTable: %s\n", logicString[useTwoLevelTable]);
        printf("UseTtValue   : %s\n", logicString[useTtValue]);
        printf("UseTtMove    : %s\n", logicString[useTtMove]);
        printf("useFlag      : %s\n", logicString[useFlag]);
        printf("timeStamp    : %s\n", logicString[timeStamp]);
    }
}                               /* PrintSettings */


void            PrintTestSettings(Signed2 testDepth, Signed2 testColor,
                                                  Signed4 testNrNodes)
{
    printf("\nTest settings\n");
    printf("-------------\n");
    printf("search with depth            : %d\n", testDepth);
    printf("search with color            : %s\n", moveColorString[testColor]);
    printf("search with max. number nodes: %d\n", testNrNodes);
    printf("----------------------------------------------------------------\n");
}




/*----------------------------------------------------------------------
 | MOVE							940426
 |
 | Contains all move procedures.
 +----------------------------------------------------------------------*/




static void     CheckRedundancies(void);


/*----------------------------------------------------------------------
 | DoMove							940426
 |
 | Performs a move internally and updates the board. Color to move
 | (toMove) is updated.
 +----------------------------------------------------------------------*/
void            DoMove(MoveType * move)
{
    BoardIndexType  square,
                    square1,
                    square2;
    SquareType      piece;
    Signed2        *evalTable;
    HashType       *hashTable;

    lastMovedPieceSquare = move->to;
    if (maxGamePlies > nrGamePlies &&
        EqualMoves(move, &(game[nrGamePlies]))) {
        ++nrGamePlies;
    } else {
        SPrintMove(gameString[nrGamePlies], *move);
        game[nrGamePlies++] = *move;
        maxGamePlies = nrGamePlies;
    }

    castling[nrGamePlies] = castling[nrGamePlies - 1];  /* Update castling and */
    HashIs(hashValue[nrGamePlies], hashValue[nrGamePlies - 1]); /* hash and */
    startHashIndex[nrGamePlies] = startHashIndex[nrGamePlies - 1];      /* index. */

    piece = board[move->from];

    /* Converting move? */
    if (IsPawn(piece) || move->capturedPiece != 0) {
        startHashIndex[nrGamePlies] = nrGamePlies;
    }
    GetEvalTable(evalTable, toMove, piece);
    positionalValue[toMove] += evalTable[move->to] - evalTable[move->from];
    GetHashTable(hashTable, toMove, piece);
    HashXorIs(hashValue[nrGamePlies], hashTable[move->from]);
    HashXorIs(hashValue[nrGamePlies], hashTable[move->to]);

    square = Square(H, 1);
    if (move->from == square || move->to == square) {
        if (castling[nrGamePlies] & WhiteShort) {
            castling[nrGamePlies] &= ~WhiteShort;
            HashXorIs(hashValue[nrGamePlies],
                      castlingHashTable[White][Short]);
        }
    }                           /* White short */
    square = Square(A, 1);
    if (move->from == square || move->to == square) {
        if (castling[nrGamePlies] & WhiteLong) {
            castling[nrGamePlies] &= ~WhiteLong;
            HashXorIs(hashValue[nrGamePlies],
                      castlingHashTable[White][Long]);
        }
    }                           /* White long */
    square = Square(H, 8);
    if (move->from == square || move->to == square) {
        if (castling[nrGamePlies] & BlackShort) {
            castling[nrGamePlies] &= ~BlackShort;
            HashXorIs(hashValue[nrGamePlies],
                      castlingHashTable[Black][Short]);
        }
    }                           /* Black short */
    square = Square(A, 8);
    if (move->from == square || move->to == square) {
        if (castling[nrGamePlies] & BlackLong) {
            castling[nrGamePlies] &= ~BlackLong;
            HashXorIs(hashValue[nrGamePlies],
                      castlingHashTable[Black][Long]);
        }
    }                           /* Black long */
    if (IsKing(piece)) {
        kingSquare[toMove] = move->to;
        if (toMove == White) {
            if (castling[nrGamePlies] & WhiteShort) {
                castling[nrGamePlies] &= ~WhiteShort;
                HashXorIs(hashValue[nrGamePlies],
                          castlingHashTable[White][Short]);
            }
            if (castling[nrGamePlies] & WhiteLong) {
                castling[nrGamePlies] &= ~WhiteLong;
                HashXorIs(hashValue[nrGamePlies],
                          castlingHashTable[White][Long]);
            }
        } else {
            if (castling[nrGamePlies] & BlackShort) {
                castling[nrGamePlies] &= ~BlackShort;
                HashXorIs(hashValue[nrGamePlies],
                          castlingHashTable[Black][Short]);
            }
            if (castling[nrGamePlies] & BlackLong) {
                castling[nrGamePlies] &= ~BlackLong;
                HashXorIs(hashValue[nrGamePlies],
                          castlingHashTable[Black][Long]);
            }
        }
    }
    /* En passant */
    if (IsEnPassantMove(move->type)) {
        square = pawnMoveTable[!toMove][move->to][0];
        material[!toMove] -= pieceValue[board[square]];
        pieces[!toMove][pieceIndex[square]] =
            pieces[!toMove][--nrPieces[!toMove]];
        pieceIndex[pieces[!toMove][pieceIndex[square]].square] =
            pieceIndex[square];
        board[square] = Empty;
        positionalValue[!toMove] -= pawnEvalTable[!toMove][square];
        HashXorIs(hashValue[nrGamePlies], pawnHashTable[!toMove][square]);
        /* Capture */
    } else if (IsCaptureMove(move->type)) {
        material[!toMove] -= pieceValue[board[move->to]];
        pieces[!toMove][pieceIndex[move->to]] =
            pieces[!toMove][--nrPieces[!toMove]];
        pieceIndex[pieces[!toMove][pieceIndex[move->to]].square] =
            pieceIndex[move->to];
        GetEvalTable(evalTable, !toMove, board[move->to]);
        positionalValue[!toMove] -= (evalTable[move->to]) + (Capture_Incentive);
        GetHashTable(hashTable, !toMove, board[move->to]);
        HashXorIs(hashValue[nrGamePlies], hashTable[move->to]);
    }
    /* Castling */
    if (IsShortCastleMove(move->type)) {
        square1 = Square(H, toMove == White ? 1 : 8);
        square2 = Square(F, toMove == White ? 1 : 8);
        board[square2] = board[square1];
        board[square1] = Empty;
        pieces[toMove][pieceIndex[square1]].square = square2;
        pieceIndex[square2] = pieceIndex[square1];
        pieceIndex[square1] = 0;
        positionalValue[toMove] += (rookEvalTable[toMove][square2] -
            rookEvalTable[toMove][square1]) + (Castling_Incentive);
        HashXorIs(hashValue[nrGamePlies], rookHashTable[toMove][square2]);
        HashXorIs(hashValue[nrGamePlies], rookHashTable[toMove][square1]);
    } else if (IsLongCastleMove(move->type)) {
        square1 = Square(A, toMove == White ? 1 : 8);
        square2 = Square(D, toMove == White ? 1 : 8);
        board[square2] = board[square1];
        board[square1] = Empty;
        pieces[toMove][pieceIndex[square1]].square = square2;
        pieceIndex[square2] = pieceIndex[square1];
        pieceIndex[square1] = 0;
        positionalValue[toMove] += (rookEvalTable[toMove][square2] -
            rookEvalTable[toMove][square1]) + (Castling_Incentive);
        HashXorIs(hashValue[nrGamePlies], rookHashTable[toMove][square2]);
        HashXorIs(hashValue[nrGamePlies], rookHashTable[toMove][square1]);
    }
    /* Promotion */
    if (IsPromotionMove(move->type)) {
        material[toMove] -= pieceValue[piece];
        board[move->from] = move->promotionPiece;
        material[toMove] += pieceValue[board[move->from]];
        pieces[toMove][pieceIndex[move->from]].type =
            move->promotionPiece;
        GetEvalTable(evalTable, toMove, move->promotionPiece);
        positionalValue[toMove] += evalTable[move->to] -
            pawnEvalTable[toMove][move->to];
        GetHashTable(hashTable, toMove, move->promotionPiece);
        HashXorIs(hashValue[nrGamePlies], hashTable[move->to]);
        HashXorIs(hashValue[nrGamePlies], pawnHashTable[toMove][move->to]);
    }
    board[move->to] = board[move->from];
    board[move->from] = Empty;
    pieces[toMove][pieceIndex[move->from]].square = move->to;
    pieceIndex[move->to] = pieceIndex[move->from];
    pieceIndex[move->from] = 0;
    if (IsDoubleMove(move->type)) {
        epSquare[nrGamePlies] = pawnMoveTable[toMove][move->from][0];
        HashXorIs(hashValue[nrGamePlies], enPassantHashTable[File(move->from)]);
    } else {
        epSquare[nrGamePlies] = NoEp;
    }
    if (epSquare[nrGamePlies - 1] != NoEp && nrGamePlies > 0) {
        HashXorIs(hashValue[nrGamePlies],
                  enPassantHashTable[File(epSquare[nrGamePlies - 1])]);
    }
    HashXorIs(hashValue[nrGamePlies], movedHash);
    toMove = !toMove;
#ifdef Debug
    CheckRedundancies();
#endif
}                               /* DoMove */


/*----------------------------------------------------------------------
 | UndoMove							940426
 |
 | Takes back a move internally and updates the board. Color to move
 | (toMove) is updated.
 +----------------------------------------------------------------------*/
void            UndoMove(void)
{
    BoardIndexType  square,
                    square1,
                    square2;
    MoveType       *move;
    SquareType      piece;
    Signed2        *table;

    move = &(game[--nrGamePlies]);
    if (nrGamePlies > 0) {
        lastMovedPieceSquare = game[nrGamePlies - 1].to;
    } else {
        lastMovedPieceSquare = 0;
    }
    toMove = !toMove;
    pieces[toMove][pieceIndex[move->to]].square = move->from;
    pieceIndex[move->from] = pieceIndex[move->to];
    pieceIndex[move->to] = 0;
    board[move->from] = board[move->to];
    board[move->to] = Empty;
    piece = board[move->from];
    if (IsKing(piece)) {
        kingSquare[toMove] = move->from;
    }
    /* Promotion */
    if (IsPromotionMove(move->type)) {
        material[toMove] -= pieceValue[board[move->from]];
        board[move->from] = Pawn | toMove;
        material[toMove] += pieceValue[board[move->from]];
        pieces[toMove][pieceIndex[move->from]].type = Pawn | toMove;
        GetEvalTable(table, toMove, piece);
        positionalValue[toMove] -= table[move->to] -
            pawnEvalTable[toMove][move->to];
        piece = Pawn | toMove;
    }
    /* Castling */
    if (IsShortCastleMove(move->type)) {
        square2 = Square(H, toMove == White ? 1 : 8);
        square1 = Square(F, toMove == White ? 1 : 8);
        board[square2] = board[square1];
        board[square1] = Empty;
        pieces[toMove][pieceIndex[square1]].square = square2;
        pieceIndex[square2] = pieceIndex[square1];
        pieceIndex[square1] = 0;
        positionalValue[toMove] -= (rookEvalTable[toMove][square1] -
            rookEvalTable[toMove][square2]) + (Castling_Incentive);
    } else if (IsLongCastleMove(move->type)) {
        square2 = Square(A, toMove == White ? 1 : 8);
        square1 = Square(D, toMove == White ? 1 : 8);
        board[square2] = board[square1];
        board[square1] = Empty;
        pieces[toMove][pieceIndex[square1]].square = square2;
        pieceIndex[square2] = pieceIndex[square1];
        pieceIndex[square1] = 0;
        positionalValue[toMove] -= (rookEvalTable[toMove][square1] -
            rookEvalTable[toMove][square2]) + (Castling_Incentive);
    }
    /* En passant */
    if (IsEnPassantMove(move->type)) {
        square = pawnMoveTable[!toMove][move->to][0];
        material[!toMove] += pieceValue[move->capturedPiece];
        pieceIndex[square] = nrPieces[!toMove]++;
        pieces[!toMove][pieceIndex[square]].type = move->capturedPiece;
        pieces[!toMove][pieceIndex[square]].square = square;
        board[square] = move->capturedPiece;
        positionalValue[!toMove] += pawnEvalTable[!toMove][square];
        /* Capture */
    } else if (IsCaptureMove(move->type)) {
        material[!toMove] += pieceValue[move->capturedPiece];
        pieceIndex[move->to] = nrPieces[!toMove]++;
        pieces[!toMove][pieceIndex[move->to]].type = move->capturedPiece;
        pieces[!toMove][pieceIndex[move->to]].square = move->to;
        board[move->to] = move->capturedPiece;
        GetEvalTable(table, !toMove, move->capturedPiece);
        positionalValue[!toMove] += (table[move->to]) + (Capture_Incentive);
    }
    GetEvalTable(table, toMove, piece);
    positionalValue[toMove] -= table[move->to] - table[move->from];
}                               /* UndoMove */


/*----------------------------------------------------------------------
 | CheckRedundancies						940427
 |
 | Checks if the board, pieces and pieceIndex are consistent.
 +----------------------------------------------------------------------*/
static void     CheckRedundancies(void)
{
    Signed2         i,
                    j;
    BoardIndexType  square;
    char            s[MaxCommandLength];

    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            square = Square(i, j);
            SPrintSquare(s, square);
            if (!IsEmpty(board[square])) {
                if (pieceIndex[square] >= nrPieces[Color(board[square])]) {
                    printf("ERROR in nrPieces on square %s\n", s);
                }
                if (pieces[Color(board[square])][pieceIndex[square]].type
                    != board[square]) {
                    printf("ERROR in type on square %s\n", s);
                }
                if (pieces[Color(board[square])][pieceIndex[square]].square
                    != square) {
                    printf("ERROR in square on square %s\n", s);
                }
            }
        }
    }
}                               /* CheckRedundancies */




/*----------------------------------------------------------------------
 | QUIES							940513
 |
 | Contains all quiescence-search functions.
 +----------------------------------------------------------------------*/


static void     GenerateQuiesMoves(MoveType ** list, Unsigned1 * nrMoves);
static void     GeneratePawnQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateKnightQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateBishopQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateRookQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves);
static void     GenerateKingQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves);


/*----------------------------------------------------------------------
 | Quiescence.							940509
 |
 | Quiescence search.
 +----------------------------------------------------------------------*/
ValueType
Quiescence(ValueType alpha, ValueType beta, PathType ** bestPath,
           Signed1 ttDepth, ValueType ttValue, Unsigned1 flag,
           Unsigned4 ttNodes)
{
    ValueType       bestValue,
                    value;
    Unsigned1       nrMoves;
    MoveType       *moveList;
    PathType       *tempPath;
    Signed2         i;
    MoveType        refMove;

    bestValue = Evaluate(ttDepth, ttValue, flag, ttNodes);
    if (bestValue >= beta) {
        ++nrLeafNodes;
        ++nrTotalNodes;
        FreePath(*bestPath);
        *bestPath = NULL;
        return (bestValue);
    }
    if (bestValue > alpha) {
        alpha = bestValue;
    }
    GenerateQuiesMoves(&moveList, &nrMoves);
    if (nrMoves == 0) {         /* (stale)mate already recognized in
                                 * Evaluate() */
        ++nrLeafNodes;
        ++nrTotalNodes;
        FreePath(*bestPath);
        *bestPath = NULL;
        return (bestValue);
    }
    ++nrInternalNodes;
    ++nrQuiesNodes;
    ++nrTotalNodes;

    /* Try refutation table move first */
    if (useRefTable && *bestPath != NULL) {
        refMove = (*bestPath)->move;
        DoMove(&refMove);
        value = -Quiescence(-beta, -alpha, &((*bestPath)->next), -2, 0, 0, 0);
        UndoMove();
        if (value <= bestValue) {
            FreePath(*bestPath);
            *bestPath = NULL;
        } else {
            bestValue = value;
            if (bestValue >= beta) {
                goto BetaCutOff;
            }
            if (bestValue > alpha) {
                alpha = bestValue;
            }
        }
    } else {
        refMove.from = 0;       /* no refutation table move */
        FreePath(*bestPath);
        *bestPath = NULL;
    }

    /* Construct heap */
    for (i = nrMoves / 2 - 1; i > 0; i--) {
        SiftDown(moveList, (Unsigned1) i, (Unsigned1) (nrMoves - 1));
    }
    for (i = nrMoves - 1; i >= 0; i--) {
        if (i != 0) {           /* Put best move above in list */
            SiftDown(moveList, (Unsigned1) 0, (Unsigned1) i);
        }
        if (EqualMoves(&(moveList[0]), &refMove)) {
            goto Next;
        }
        DoMove(&(moveList[0]));
        tempPath = NULL;
        value = -Quiescence(-beta, -alpha, &tempPath, -2, 0, 0, 0);
        UndoMove();
        if (value > bestValue) {
            bestValue = value;
            FreePath(*bestPath);
            AllocatePathMove(*bestPath);
            SPrintMove((*bestPath)->moveString, moveList[0]);
            (*bestPath)->move = moveList[0];
            (*bestPath)->next = tempPath;
            if (bestValue >= beta) {
                goto BetaCutOff;
            }
            if (bestValue > alpha) {
                alpha = bestValue;
            }
        } else {
            FreePath(tempPath);
        }
Next:
        if (i != 0) {
            moveList[0] = moveList[i];
        }
    }                           /* for */
BetaCutOff:
    FreeMoveList(moveList);
    return (bestValue);
}                               /* Quiescence */


/*----------------------------------------------------------------------
 | GenerateQuiesMoves						940513
 |
 | Generates all legal quiescence moves.
 +----------------------------------------------------------------------*/
static void     GenerateQuiesMoves(MoveType ** moveList, Unsigned1 * nrMoves)
{
    PieceType      *pieceTable;
    Unsigned1       nr;
    SquareType      piece;
    Signed2         i;
    MoveType        list[MaxMoves];
   

    pieceTable = pieces[toMove];
    nr = nrPieces[toMove];

    *nrMoves = 0;
    /* already done in Evaluate() */
//	SearchForPinsAndCheck(); 
    switch (nrCheck) {
    case 0:
        for (i = 0; i < nr; i++) {
            piece = pieceTable[i].type;
             
            if (IsPawn(piece)) {
                GeneratePawnQuiesMoves(pieceTable[i].square, list, nrMoves);
            } else if (IsKnight(piece) && !pinned[pieceTable[i].square]) {
                GenerateKnightQuiesMoves(pieceTable[i].square, list, nrMoves);
            } else if (IsKing(piece)) {
                GenerateKingQuiesMoves(pieceTable[i].square, list, nrMoves);
            } else {
                if (MovesDiagonal(piece)) {
                    GenerateBishopQuiesMoves(pieceTable[i].square, list, nrMoves);
                }
                if (MovesStraight(piece)) {
                    GenerateRookQuiesMoves(pieceTable[i].square, list, nrMoves);
                }
            }
        }                       /* for i */
        break;
    case 1:
        /* Capture check-giving piece, NOT with king */
        GenerateCaptureMoves(&(checkingPiece[0]), list, nrMoves);
        /* Interpose piece */
        if (checkingPiece[0].dir &&
            kingSquare[toMove] + checkingPiece[0].dir !=
            checkingPiece[0].square) {
            GenerateInterposingMoves(&(checkingPiece[0]), list, nrMoves);
        }
    case 2:
        /* Move king away, including trying to capture (one of) the
         * check-giving piece(s) */
        GenerateKingMoves(kingSquare[toMove], list, nrMoves);
        break;
    default:
        printf("ERROR: %d times in check\n", nrCheck);
        exit(0);
    }                           /* switch */
    if (*nrMoves) {
        AllocateMoveList(*moveList, *nrMoves);
        memcpy(*moveList, list, *nrMoves * sizeof(MoveType));
    }
/*  HeapSort( *moveList, *nrMoves );
   qsort( *moveList, *nrMoves, sizeof( MoveType ), CompareMoves ); */
}                               /* GenerateQuiesMoves */


/*----------------------------------------------------------------------
 | GeneratePawnQuiesMoves					940513
 |
 | Generates all legal pawn quiescence moves.
 +----------------------------------------------------------------------*/
static void     GeneratePawnQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves)
{
    BoardIndexType  to;
    SquareType      piece;
    Unsigned1       dir;
    PieceType       attackingPiece;

    /* promotion moves */
    if (!pinned[from] || pinned[from] == Up || pinned[from] == Down) {
        to = pawnMoveTable[toMove][from][0];
        if (IsEmpty(board[to]) && OnSeventhRank(toMove, from)) {
            PutMoveInTable(from, to, 0, Queen | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Knight | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Rook | toMove, Promotion, list,
                           *nrMoves);
            PutMoveInTable(from, to, 0, Bishop | toMove, Promotion, list,
                           *nrMoves);
        }                       /* if promotion move */
    }                           /* if not pinned */
    /* capture moves */
    for (dir = 0; dir < 2; dir++) {
        if (!pinned[from] || pinned[from] == pawnCaptureDir[toMove][dir] ||
            pinned[from] == -pawnCaptureDir[toMove][dir]) {
            to = pawnCaptureTable[toMove][from][dir];
            if (to == epSquare[nrGamePlies]) {
                if (Rank(kingSquare[toMove]) != (toMove == White ? 5 : 4)) {
                    PutMoveInTable(from, to, Pawn | !toMove, 0,
                                   EnPassant | Capture, list, *nrMoves);
                } else {
                    /* remove pawns temporarily */
                    board[from] = Empty;
                    board[to + (toMove == White ? Down : Up)] = Empty;
                    if (!FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                       rookTable[kingSquare[toMove]][2], &attackingPiece) ||
                        (attackingPiece.type != (Rook | !toMove) &&
                         attackingPiece.type != (Queen | !toMove))) {
                        if (!FindFirstPieceInDir((Unsigned1) MaxRookMoves,
                        rookTable[kingSquare[toMove]][3], &attackingPiece) ||
                            (attackingPiece.type != (Rook | !toMove) &&
                             attackingPiece.type != (Queen | !toMove))) {
                            PutMoveInTable(from, to, Pawn | !toMove, 0,
                                       EnPassant | Capture, list, *nrMoves);
                        }
                    }
                    /* Put pawns back */
                    board[from] = Pawn | toMove;
                    board[to + (toMove == White ? Down : Up)] = Pawn | !toMove;
                }
            } else {            /* no en-passant move */
                piece = board[to];
                if (piece && !IsEdge(piece) && !IsColor(piece, toMove)) {
                    if (OnSeventhRank(toMove, from)) {
                        PutMoveInTable(from, to, piece, Queen | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Knight | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Rook | toMove,
                                       Promotion | Capture, list, *nrMoves);
                        PutMoveInTable(from, to, piece, Bishop | toMove,
                                       Promotion | Capture, list, *nrMoves);
                    } else {
                        PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    }
                }               /* if enemy piece */
            }                   /* else */
        }                       /* if not pinned */
    }                           /* for dir */
}                               /* GeneratePawnQuiesMoves */


/*----------------------------------------------------------------------
 | GenerateKnightQuiesMoves					940513
 |
 | Generates all legal knight quiescence moves.
 +----------------------------------------------------------------------*/
static void     GenerateKnightQuiesMoves(BoardIndexType from, MoveType * list,
                                                         Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < MaxKnightMoves; i++) {
        to = knightTable[from][i];
        if (!to) {
            break;
        }
        piece = board[to];
        /* capture moves only */
        if (!IsEmpty(piece) && !IsEdge(piece) && !IsColor(piece, toMove)) {
            PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
        }
    }
}                               /* GenerateKnightQuiesMoves */


/*----------------------------------------------------------------------
 | GenerateBishopQuiesMoves					940513
 |
 | Generates all legal bishop quiescence moves.
 +----------------------------------------------------------------------*/
static void     GenerateBishopQuiesMoves(BoardIndexType from, MoveType * list,
                                                         Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == bishopDir[i] ||
            pinned[from] == -bishopDir[i]) {
            for (j = 0; j < MaxBishopMoves; j++) {
                to = bishopTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    continue;
                }
                /* capture moves only */
                if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    break;
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
}                               /* GenerateBishopQuiesMoves */


/*----------------------------------------------------------------------
 | GenerateRookQuiesMoves					940513
 |
 | Generates all legal quiescence rook moves.
 +----------------------------------------------------------------------*/
static void     GenerateRookQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves)
{
    Signed2         i,
                    j;
    BoardIndexType  to;
    SquareType      piece;

    for (i = 0; i < 4; i++) {
        if (!pinned[from] || pinned[from] == rookDir[i] ||
            pinned[from] == -rookDir[i]) {
            for (j = 0; j < MaxRookMoves; j++) {
                to = rookTable[from][i][j];
                if (!to) {
                    break;
                }
                piece = board[to];
                if (IsEmpty(piece)) {
                    continue;
                }
                /* capture moves only */
                if (!IsEdge(piece) && !IsColor(piece, toMove)) {
                    PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
                    break;
                } else {
                    break;
                }
            }                   /* for j */
        }                       /* if not pinned */
    }                           /* for i */
}                               /* GenerateRookQuiesMoves */


/*----------------------------------------------------------------------
 | GenerateKingQuiesMoves					940513
 |
 | Generates all legal king quiescence moves.
 +----------------------------------------------------------------------*/
static void     GenerateKingQuiesMoves(BoardIndexType from, MoveType * list,
                                                       Unsigned1 * nrMoves)
{
    Signed2         i;
    BoardIndexType  to;
    SquareType      piece;

    /* Remove king temporarily in view of Attacked() */
    board[kingSquare[toMove]] = Empty;
    for (i = 0; i < 4; i++) {
        to = rookTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        /* capture moves only */
        if (!IsEmpty(piece) && !IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-rookDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
            }
        }
    }
    for (i = 0; i < 4; i++) {
        to = bishopTable[from][i][0];
        if (!to) {
            continue;
        }
        piece = board[to];
        /* capture moves only */
        if (!IsEmpty(piece) && !IsEdge(piece) && !IsColor(piece, toMove)) {
            if (!IsCheckingDir(-bishopDir[i]) &&
                !Attacked(to, (SquareType) ! toMove)) {
                PutMoveInTable(from, to, piece, 0, Capture, list, *nrMoves);
            }
        }
    }
    board[kingSquare[toMove]] = King | toMove;
}                               /* GenerateKingQuiesMoves */





/*----------------------------------------------------------------------
 | SEARCH                                                    940608
 |
 | Contains all search functions.
 +----------------------------------------------------------------------*/


void            PreProcessing(void)
{
    Signed2         i,
                    j;
    BoardIndexType  square;

    ClearPieceSquareTables();
    for (i = A; i <= H; i++) {
        for (j = 1; j <= 8; j++) {
            square = Square(i, j);
            pawnEvalTable[White][square] = PawnTable[square] + 6 * j;
            knightEvalTable[White][square] = KnightTable[square];
            bishopEvalTable[White][square] = BishopTable[square];
            rookEvalTable[White][square] = RookTable[square];
            queenEvalTable[White][square] = QueenTable[square];
            kingEvalTable[White][square] = -centreTable[square];

            pawnEvalTable[Black][square] = PawnTable[square] + 6 * (9 - j);
            knightEvalTable[Black][square] = KnightTable[square];
            bishopEvalTable[Black][square] = BishopTable[square];
            rookEvalTable[Black][square] = RookTable[square];
            queenEvalTable[Black][square] = QueenTable[square];
            kingEvalTable[Black][square] = -centreTable[square];
        }
    }
    InitPositionalValue();
}                               /* PreProcessing */


Signed2
ItIsADraw(void)
{
    Signed2         i;

    if (nrGamePlies - startHashIndex[nrGamePlies] >= 100) {
        return (True);
    }
    for (i = (Signed2) nrGamePlies - 2; i >= (Signed2) startHashIndex[nrGamePlies];
         i -= 2) {
        if (HashEqual(hashValue[nrGamePlies], hashValue[i])) {
            return (True);
        }
    }
    return (False);
}                               /* ItIsADraw */


























